/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package forme.otpremnica.model;

import forme.partner.model.*;
import domen.FizickoLice;
import domen.Mesto;
import domen.Otpremnica;
import domen.Proizvod;
import domen.StavkaOtpremnice;
import java.util.List;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author student1
 */
public class OtpremnicaModelTabele extends AbstractTableModel {

    private Otpremnica otpremnica;

    public OtpremnicaModelTabele(Otpremnica otpremnica) {
        this.otpremnica = otpremnica;
    }

    @Override
    public int getRowCount() {
        if (otpremnica == null) {
            return 0;
        }
        if (otpremnica.getListaStavki() == null) {
            return 0;
        }
        return otpremnica.getListaStavki().size();
    }

    @Override
    public int getColumnCount() {
        return 5;
    }

    @Override
    public Object getValueAt(int rowIndex, int columnIndex) {
        StavkaOtpremnice stavka = otpremnica.getListaStavki().get(rowIndex);
        switch (columnIndex) {
            case 0:
                return stavka.getRb();
            case 1:
                return stavka.getProizvod();
            case 2:
                return stavka.getCena();
            case 3:
                return stavka.getKolicina();
            case 4:
                return stavka.getIznosStavke();
            default:
                return "Greska";
        }
    }

    public void dodajRed(StavkaOtpremnice so) {
        otpremnica.getListaStavki().add(so);
        fireTableDataChanged();
    }

    public void dodajRed() {
        StavkaOtpremnice stavka = new StavkaOtpremnice();
        stavka.setRb(otpremnica.getListaStavki().size() + 1);
        otpremnica.getListaStavki().add(stavka);
        fireTableDataChanged();
    }

    @Override
    public boolean isCellEditable(int rowIndex, int columnIndex) {
        if (columnIndex == 0) {
            return false;
        }
        if (columnIndex == 4) {
            return false;
        }
        return true;
    }

    @Override
    public void setValueAt(Object aValue, int rowIndex, int columnIndex) {
        StavkaOtpremnice stavka = otpremnica.getListaStavki().get(rowIndex);
        switch (columnIndex) {
            case 0: //korisnik ne moze da menja ovu vrednost u tabeli
                break;
            case 1:
                stavka.setProizvod((Proizvod) aValue);
                stavka.setCena(stavka.getProizvod().getCena());
                stavka.setIznosStavke(stavka.getCena() * stavka.getKolicina());
                break;
            case 2:
                stavka.setCena(Double.parseDouble(aValue.toString()));
                break;
            case 3:
                stavka.setKolicina(Integer.parseInt(aValue.toString()));
                stavka.setIznosStavke(stavka.getCena() * stavka.getKolicina());
                break;
            case 4:
                //ovu vrednost korisnik ne menja
                break;

        }
    }

    @Override
    public String getColumnName(int column) {
        switch (column) {
            case 0:
                return "RB";
            case 1:
                return "Proizvod";
            case 2:
                return "Cena";
            case 3:
                return "Kolicina";
            case 4:
                return "Iznos";
            default:
                return "Greska";
        }
    }

    public Otpremnica vratiOtpremnicu() {
        return otpremnica;
    }
}
