/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package kontroler;

import db.DbKomunikacija;
import domen.FizickoLice;
import domen.Mesto;
import domen.Otpremnica;
import domen.PoslovniPartner;
import domen.Proizvod;
import domen.StavkaOtpremnice;
import java.util.List;
import kontekst.Kontekst;

/**
 *
 * @author student1
 */
public class Kontroler {

    private DbKomunikacija db;
    private Kontekst kontekst;
    private static Kontroler k;

    private Kontroler() {
        db = new DbKomunikacija();
        kontekst = new Kontekst();
    }

    public static Kontroler vratiObjekat() {
        if (k == null) {
            k = new Kontroler();
        }
        return k;
    }

    public void sacuvajMesto(Mesto mesto) throws Exception {
        db.ucitajDriver();
        db.uspostaviKonekciju();
        db.sacuvajMesto(mesto);
        db.commitTransakcije();
        db.zatvoriKonekciju();
    }

    public List<Mesto> vratiMesta() throws Exception {
        db.ucitajDriver();
        db.uspostaviKonekciju();
        List<Mesto> lm = db.vratiMesta();
        db.commitTransakcije();
        db.zatvoriKonekciju();
        return lm;
    }

    public void sacuvajFizickaLica(List<FizickoLice> lista) throws Exception {
        try {
            db.ucitajDriver();
            db.uspostaviKonekciju();
            for (FizickoLice f : lista) {
                db.sacuvajFizickoLice(f);
                System.out.println("Sacuvao: " + f);
            }
            db.commitTransakcije();
            db.zatvoriKonekciju();
        } catch (Exception ex) {
            ex.printStackTrace();
            db.rollbackTransakcije();
            db.zatvoriKonekciju();
            throw ex;
        }

    }

    public List<PoslovniPartner> vratiSvePoslovnePartnere() throws Exception {
        db.ucitajDriver();
        db.uspostaviKonekciju();
        List<PoslovniPartner> lpp = db.vratiSvePoslovnePartnere();
        db.commitTransakcije();
        db.zatvoriKonekciju();
        return lpp;
    }

    public List<Proizvod> vratiSveProizvode() throws Exception {
        db.ucitajDriver();
        db.uspostaviKonekciju();
        List<Proizvod> lp = db.vratiSveProizvode();
        db.commitTransakcije();
        db.zatvoriKonekciju();
        return lp;
    }

    public void sacuvajOtpremnicu(Otpremnica o) throws Exception {
        db.ucitajDriver();
        db.uspostaviKonekciju();
        try {
            db.sacuvajOtpremnicu(o);
            //sacuvaj otpremnicu
            db.commitTransakcije();
        } catch (Exception e) {
            db.rollbackTransakcije();
            throw  new Exception("Greska prilikom cuvanja otpremnice");
        }
        db.zatvoriKonekciju();
    }
    
    public void sacuvajOtpremnicu_v2(Otpremnica o) throws Exception {
        db.ucitajDriver();
        db.uspostaviKonekciju();
        try {
            //sacuvajOtpremnicu
            for (StavkaOtpremnice  so : o.getListaStavki()) {
                //sacuvaj stavku otpremnice
            }
            
            db.commitTransakcije();
        } catch (Exception e) {
            db.rollbackTransakcije();
            throw  new Exception("Greska prilikom cuvanja otpremnice");
        }
        db.zatvoriKonekciju();
    }
    
}
