/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package db;

import domen.Mesto;
import java.math.BigDecimal;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author student1
 */
public class DbKomunikacija {
    private Connection konekcija;
    
    public void ucitajDriver() throws ClassNotFoundException {
        Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
    }
    
    public void uspostaviKonekciju() throws SQLException {
        konekcija = DriverManager.getConnection("jdbc:odbc:D3");
    }
    
    public void zatvoriKonekciju() throws SQLException {
        konekcija.close();
    }
    
    public void sacuvajMesto(Mesto mesto) throws Exception {
        try {
            String sql = "INSERT INTO MESTO VALUES (?,?)";            
            PreparedStatement sqlNaredba = konekcija.prepareStatement(sql);
            //sqlNaredba.setLong(1, mesto.getPtt());
            sqlNaredba.setBigDecimal(1, new BigDecimal(mesto.getPtt()));
            sqlNaredba.setString(2, mesto.getNaziv());
            sqlNaredba.executeUpdate();
            sqlNaredba.close();
        } catch (SQLException ex) {
            ex.printStackTrace();
            throw new Exception("Greska pri cuvanju mesta!");
        }
    }
    
    public List<Mesto> vratiMesta() throws Exception {
        List<Mesto> lm = new ArrayList<Mesto>();
        try {
            String sql = "SELECT * FROM Mesto";
            Statement sqlNaredba = konekcija.createStatement();
            ResultSet mesta = sqlNaredba.executeQuery(sql);
            while (mesta.next()) {
                long ptt = mesta.getLong(1);
                String naziv = mesta.getString("Naziv");
                Mesto m = new Mesto(ptt, naziv);
                lm.add(m);
            }
        } catch (SQLException ex) {
            ex.printStackTrace();
            throw new Exception("Greska pri ucitavanju mesta!");
        }
        return lm;
    }
}
