/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package baza;

import domen.FizickoLice;
import domen.Mesto;
import java.math.BigDecimal;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author student1
 */
public class DbKomunikacija {
    private Connection konekcija;
    public void ucitajDriver() throws ClassNotFoundException {
        Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
    }
    
    public void otvoriKonekciju() throws SQLException {
        konekcija = DriverManager.getConnection("jdbc:odbc:D4");
        konekcija.setAutoCommit(false); // Zahteva eksplicitnu potvrdu transakcije
    }
    
    public void zatvoriKonekciju() throws SQLException {
        konekcija.close();
    }
    
    public void commitTransakcije() throws Exception {
        try {
            konekcija.commit();
        } catch (SQLException ex) {
            ex.printStackTrace();
            throw new Exception("Greska pri potvrdi transakcije!");
        }
    }
    
    public void rollbackTransakcije() throws Exception {
        try {
            konekcija.rollback();
        } catch (SQLException ex) {
            ex.printStackTrace();
            throw new Exception("Greska pri ponistenju transakcije!");
        }
    }
    public void sacuvajMesto(Mesto mesto) throws Exception {
        try {
            String sql = "INSERT INTO Mesto VALUES (?,?)";
            PreparedStatement sqlNaredba = konekcija.prepareStatement(sql);
            //sqlNaredba.setLong(1, mesto.getPtt());
            sqlNaredba.setBigDecimal(1, new BigDecimal(mesto.getPtt()));
            sqlNaredba.setString(2, mesto.getNaziv());
            sqlNaredba.executeUpdate();
            sqlNaredba.close();
        } catch (SQLException ex) {
            ex.printStackTrace();
            throw new Exception("Grska pri cuvanju mesta!");
        }
    }
    
    public List<Mesto> vratiMesta() throws Exception {
        List<Mesto> lm = new ArrayList<Mesto>();
        try {
            String sql = "SELECT * FROM Mesto";
            Statement sqlNaredba = konekcija.createStatement();
            ResultSet mesta = sqlNaredba.executeQuery(sql);
            while (mesta.next()) {
                long ptt = mesta.getLong(1);
                String naziv = mesta.getString("Naziv");
                Mesto m = new Mesto(ptt, naziv);
                lm.add(m);
            }
            mesta.close();
            sqlNaredba.close();
        } catch (SQLException ex) {
            ex.printStackTrace();
            throw new Exception("Grska pri citanju mesta!");
        }
        return lm;
    }
    
    public void sacuvajFizickoLice(FizickoLice f) throws Exception {
        try {
            String sql = "INSERT INTO PoslovniPartner VALUES (?,?,?,?)";
            PreparedStatement sqlNaredba = konekcija.prepareStatement(sql);
            sqlNaredba.setInt(1, f.getPartnerID());
            sqlNaredba.setString(2, f.vratiAdresu().getNazivUlice());
            sqlNaredba.setString(3, f.vratiAdresu().getBrojUlice());
            sqlNaredba.setBigDecimal(4, new BigDecimal(f.vratiAdresu().getM().getPtt()));
            sqlNaredba.executeUpdate();
            sqlNaredba.close();
            
            sql = "INSERT INTO FizickoLice VALUES (?,?,?,?,?)";
            sqlNaredba = konekcija.prepareStatement(sql);
            sqlNaredba.setInt(1, f.getPartnerID());
            sqlNaredba.setString(2, f.getJMBG());
            sqlNaredba.setString(3, f.getIme());
            sqlNaredba.setString(4, f.getPrezime());
            sqlNaredba.setInt(5, f.getGodRod());
            sqlNaredba.executeUpdate();
            sqlNaredba.close();
        } catch(SQLException ex) {
            ex.printStackTrace();
            throw new Exception("Grska pri cuvanju fizickog lica!");
        }
    }
    
}
