/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package tabela.model;

import domen.FizickoLice;
import domen.Mesto;
import java.util.List;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author student1
 */
public class ModelTabeleFL extends AbstractTableModel {
    private List<FizickoLice> lista;

    public ModelTabeleFL(List<FizickoLice> lista) {
        this.lista = lista;
    }

    @Override
    public int getRowCount() {
        if (lista == null) {
            return 0;
        }
        return lista.size();
    }

    @Override
    public int getColumnCount() {
        return 8;
    }

    @Override
    public Object getValueAt(int rowIndex, int columnIndex) {
        FizickoLice f = (FizickoLice)lista.get(rowIndex);
        switch (columnIndex) {
            case 0: return f.getPartnerID();
            case 1: return f.getJMBG();
            case 2: return f.getIme();
            case 3: return f.getPrezime();
            case 4: return f.getGodRod();
            case 5: return f.vratiAdresu().getNazivUlice();
            case 6: return f.vratiAdresu().getBrojUlice();
            case 7: return f.vratiAdresu().getM();
            default: return "Greska";
        }
    }

    @Override
    public String getColumnName(int column) {
        switch (column) {
            case 0: return "PartnerID";
            case 1: return "JMBG";
            case 2: return "Ime";
            case 3: return "Prezime";
            case 4: return "GodRodj";
            case 5: return "Ulica";
            case 6: return "Broj";
            case 7: return "Mesto";
            default: return "";
                
        }
    }
    
    public void dodajRed(FizickoLice f) {
        lista.add(f);
        fireTableDataChanged();
    }

    @Override
    public boolean isCellEditable(int rowIndex, int columnIndex) {
        return true;
    }

    @Override
    public void setValueAt(Object aValue, int rowIndex, int columnIndex) {
        FizickoLice f = lista.get(rowIndex);
        switch (columnIndex) {
            case 0: f.setPartnerID(Integer.parseInt((String)aValue)); break;
            case 1: f.setJMBG((String)aValue); break;
            case 2: f.setIme((String)aValue); break;
            case 3: f.setPrezime((String)aValue); break;
            case 4: f.setGodRod(Integer.parseInt((String)aValue)); break;
            case 5: f.vratiAdresu().setNazivUlice((String)aValue); break;
            case 6: f.vratiAdresu().setBrojUlice((String)aValue); break;
            case 7: f.vratiAdresu().setM((Mesto)aValue); break;
        }
    }
    
    public List<FizickoLice> vratiPodatke() {
        return lista;
    }
    
    public void obrisiRed(int rb) {
        lista.remove(rb);
        fireTableDataChanged();
    }
    
    public FizickoLice vratiRed(int red) {
        return lista.get(red);
    }
}
