/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package forme.partner.model;

import domen.FizickoLice;
import domen.Mesto;
import java.util.List;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author student1
 */
public class FizickoLiceModelTabele extends AbstractTableModel {
    private List<FizickoLice> lista;

    public FizickoLiceModelTabele(List<FizickoLice> lista) {
        this.lista = lista;
    }
    
    @Override
    public int getRowCount() {
        if (lista == null) {
            return 0;
        }
        return lista.size();
    }

    @Override
    public int getColumnCount() {
        return 8;
    }

    @Override
    public Object getValueAt(int rowIndex, int columnIndex) {
        FizickoLice f = lista.get(rowIndex);
        switch (columnIndex) {
            case 0: return f.getPartnerID();
            case 1: return f.getJmbg();
            case 2: return f.getIme();
            case 3: return f.getPrezime();
            case 4: return f.getGodRodj();
            case 5: return f.getAdresa().getNazivUlice();
            case 6: return f.getAdresa().getBroj();
            case 7: return f.getAdresa().getMesto();
            default: return "Greska";
        }
    }
    
    public void dodajRed(FizickoLice f) {
        lista.add(f);
        fireTableDataChanged();
    }
    
    public List<FizickoLice> vratiPodatke() {
        return lista;
    }
    
    public void obrisiRed(int rb) {
        lista.remove(rb);
        fireTableDataChanged();
    }
    
    public FizickoLice vratiRed(int rb) {
        return lista.get(rb);
    }

    @Override
    public boolean isCellEditable(int rowIndex, int columnIndex) {
        return true;
    }

    @Override
    public void setValueAt(Object aValue, int rowIndex, int columnIndex) {
        FizickoLice f = lista.get(rowIndex);
        switch (columnIndex) {
            case 0: f.setPartnerID(Integer.parseInt((String)aValue)); break;
            case 1: f.setJmbg((String)aValue); break;
            case 2: f.setIme((String)aValue); break;
            case 3: f.setPrezime((String)aValue); break;
            case 4: f.setGodRodj(Integer.parseInt((String)aValue)); break;
            case 5: f.getAdresa().setNazivUlice((String)aValue); break;
            case 6: f.getAdresa().setBroj((String)aValue); break;
            case 7: f.getAdresa().setMesto((Mesto)aValue); break;
        }
    }
}
