/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package forme.otpremnica.model;

import forme.partner.model.*;
import domen.FizickoLice;
import domen.Mesto;
import domen.Otpremnica;
import domen.Proizvod;
import domen.StavkaOtpremnice;
import java.util.List;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author student1
 */
public class OtpremnicaModelTabele extends AbstractTableModel {

    private Otpremnica otpremnica;

    public OtpremnicaModelTabele(Otpremnica otpremnica) {
        this.otpremnica = otpremnica;
    }

    @Override
    public int getRowCount() {
        if (otpremnica == null) {
            return 0;
        }
        if (otpremnica.getListaStavki() == null) {
            return 0;
        }
        return otpremnica.getListaStavki().size();
    }

    @Override
    public int getColumnCount() {
        return 5;
    }

    @Override
    public Object getValueAt(int rowIndex, int columnIndex) {
        StavkaOtpremnice stavka = otpremnica.getListaStavki().get(rowIndex);
        switch (columnIndex) {
            case 0:
                return stavka.getRb();
            case 1:
                return stavka.getProizvod();
            case 2:
                return stavka.getKolicina();
            case 3:
                return stavka.getCena();
            case 4:
                return stavka.getIznosStavke();

            default:
                return "Greska";
        }
    }

    public void dodajRed(StavkaOtpremnice st) {
        otpremnica.getListaStavki().add(st);
        fireTableDataChanged();
    }

    @Override
    public boolean isCellEditable(int rowIndex, int columnIndex) {
        if (columnIndex == 0) {
            return false;
        }
        if (columnIndex == 4) {
            return false;
        }
        return true;
    }

    @Override
    public void setValueAt(Object aValue, int rowIndex, int columnIndex) {
        StavkaOtpremnice so = otpremnica.getListaStavki().get(rowIndex);
        switch (columnIndex) {
            case 0:
                //korisnik ne menja vrednosti
                break;
            case 1:
                so.setProizvod((Proizvod) aValue);
                so.setCena(((Proizvod) aValue).getCena());
                so.setIznosStavke(so.getKolicina() * so.getCena());
                break;
            case 2:
                so.setKolicina(Integer.parseInt(aValue.toString()));
                so.setIznosStavke(so.getKolicina() * so.getCena());
                break;
            case 3:
                so.setCena(Double.parseDouble(aValue.toString()));
                so.setIznosStavke(so.getKolicina() * so.getCena());
                break;
            case 4:
                //korisnik ne menja vrednost u tabeli
                break;

        }

    }

    @Override
    public String getColumnName(int column) {
        switch (column) {
            case 0:
                return "RB";
            case 1:
                return "Proizvod";
            case 2:
                return "Kolicina";
            case 3:
                return "Cena";
            case 4:
                return "Iznos stavke";

            default:
                return "Greska";
        }
    }

    public Otpremnica vratiOtpremnicu() {
        return otpremnica;
    }
}
