/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package logic;

import db.DBBroker;
import domen.FizickoLice;
import domen.Mesto;
import domen.PoslovniPartner;
import java.util.ArrayList;

/**
 *
 * @author student1
 */
public class Kontroler {
    private ArrayList<Mesto> mesta;
    private ArrayList<PoslovniPartner> poslovniPartneri;
    
    private Kontroler(){
        mesta=new ArrayList<Mesto>();
        poslovniPartneri = new ArrayList<PoslovniPartner>();
        inicijalizujListuMesta();
    }
    private static Kontroler instance;
    public static Kontroler getInstance(){
        if(instance==null){
            instance=new Kontroler();
        }
        return instance;
    }
    
    public void dodajMesto(Mesto mesto) throws Exception{
        //mesta.add(mesto);
        DBBroker dbbr = new DBBroker();
        dbbr.sacuvajMesto(mesto);
    }
    
    public ArrayList<Mesto> vratiSvaMesta() throws Exception{
        //return mesta;
        
        DBBroker dbbr = new DBBroker();
        return dbbr.vratiSvaMesta();
    }
    
    public void dodajPoslovnogPartnera(PoslovniPartner poslovniPartner){
        poslovniPartneri.add(poslovniPartner);
    }
    
    public ArrayList<PoslovniPartner> vratiSvePoslovnePartnere(){
        return poslovniPartneri;
    }
    
    public ArrayList<PoslovniPartner> vratiPoslovnePartnereIzMesta(Mesto mesto){
        ArrayList<PoslovniPartner> selektovaniPoslovniPartneri = new ArrayList<PoslovniPartner>();
        for (PoslovniPartner poslovniPartner : poslovniPartneri) {
            if(poslovniPartner.getAdresa().getMesto().equals(mesto)){
                selektovaniPoslovniPartneri.add(poslovniPartner);
            }
        }
        return selektovaniPoslovniPartneri;
    }
    
    public ArrayList<FizickoLice> vratiFizickaLica(){
        
        ArrayList<FizickoLice> listaFizickoLica = new ArrayList<>();
        
        
        for (int i = 0; i < poslovniPartneri.size(); i++) {
          
        try{
            FizickoLice fl = (FizickoLice) poslovniPartneri.get(i);
            listaFizickoLica.add(fl);
          }catch(Exception ex){
              //
          }  
        }
        return listaFizickoLica;
        
    }
    

    private void inicijalizujListuMesta() {
        mesta.add(new Mesto(11000, "Beograd"));
        mesta.add(new Mesto(11070, "Novi Beograd"));
        mesta.add(new Mesto(11080, "Zemun"));
        mesta.add(new Mesto(21000, "Novi Sad"));
    }
    
}
