/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package db;

import domen.FizickoLice;
import domen.Mesto;
import domen.Otpremnica;
import domen.PoslovniPartner;
import domen.PravnoLice;
import domen.Proizvod;
import domen.StavkaOtpreminice;
import java.sql.Connection;
import java.sql.Date;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author student1
 */
public class DBBroker {
    
    Connection konekcija;
    
     public void otvoriBazu() throws ClassNotFoundException, SQLException {
        Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
        String url = "jdbc:odbc:D2_Partneri";
        String user = "";
        String password = "";
        konekcija = DriverManager.getConnection(url, user, password);
        konekcija.setAutoCommit(false);
    }

    public void zatvoriBazu() throws SQLException {
        konekcija.close();
    }

    public void commitTransakcije() throws SQLException {
        konekcija.commit();
    }

    public void rollbackTransakcije() throws SQLException {
        konekcija.rollback();
    }
    
    public void sacuvajMesto(Mesto m) throws Exception{
        try {
             
//            String upit = "INSERT INTO MESTO VALUES ("+m.getPtt()+",'"+m.getNaziv()+"')";
//            Statement naredba = konekcija.createStatement();
//            naredba.executeUpdate(upit);
            
            
              String upit = "INSERT INTO MESTO VALUES (?,?)";
              PreparedStatement naredba = konekcija.prepareStatement(upit);
              naredba.setInt(1, m.getPtt());
              naredba.setString(2, m.getNaziv());
              naredba.executeUpdate();
            
              konekcija.close();
              
            
      
        } catch (SQLException ex) {
            Logger.getLogger(DBBroker.class.getName()).log(Level.SEVERE, null, ex);
        }
        
    }
    
    
    public ArrayList<Mesto> vratiSvaMesta() throws Exception{
        try {
            
            String upit = "SELECT * FROM MESTO";
            Statement naredba = konekcija.createStatement();
            ResultSet rs = naredba.executeQuery(upit);
            ArrayList<Mesto> listaMesta = new ArrayList<>();
            
            while (rs.next()){
                
                Mesto m = new Mesto();
                
                m.setPtt(rs.getInt("ptt"));
                m.setNaziv(rs.getString("naziv"));
                
                listaMesta.add(m);
            }
            
            return listaMesta;
            
        }catch (SQLException ex) {
            Logger.getLogger(DBBroker.class.getName()).log(Level.SEVERE, null, ex);
            throw ex;
        }
           
                
    }
    
    public void sacuvajSvaFizickaLica(List<FizickoLice> listaFL) throws Exception{
        
         
         String upitPP = "INSERT INTO POSLOVNIPARTNER VALUES (?,?,?,?)";
        
         
         String upitFL = "INSERT INTO FIZICKOLICE VALUES (?,?,?,?,?)";
         
         
         for (Iterator<FizickoLice> it = listaFL.iterator(); it.hasNext();) {
            FizickoLice fizickoLice = it.next();
            try{
            PreparedStatement ps = konekcija.prepareStatement(upitPP);
            ps.setInt(1, fizickoLice.getPartnerID());
            ps.setString(2, fizickoLice.getAdresa().getNazivUlice());
            ps.setString(3, fizickoLice.getAdresa().getBroj());
            ps.setLong(4, fizickoLice.getAdresa().getMesto().getPtt());
            
            ps.executeUpdate();
            
            ps = konekcija.prepareStatement(upitFL);
            ps.setInt(1, fizickoLice.getPartnerID());
            ps.setString(2, fizickoLice.getJmbg());
            ps.setString(3, fizickoLice.getIme());
            ps.setString(4, fizickoLice.getPrezime());
            ps.setInt(5, fizickoLice.getGodRodj());
            
            ps.executeUpdate();
            
            konekcija.commit();
            
            }catch(Exception ex){
                ex.printStackTrace();
                konekcija.rollback();
            }
            
        }

        
        
    }
    
    public ArrayList<PoslovniPartner> vratiSvePoslovnePartnere() throws SQLException {
        ArrayList<PoslovniPartner> partneri = new ArrayList<>();

        partneri.addAll(vratiSvaFizickaLica());
        partneri.addAll(vratiSvaPravnaLica());

        return partneri;
    }

    public ArrayList<FizickoLice> vratiSvaFizickaLica() throws SQLException {
        ArrayList<FizickoLice> fizickaLica = new ArrayList<>();
        String upit = "SELECT PoslovniPartner.PartnerID, ime, prezime, jmbg, nazivUlice, broj, Mesto.pttBroj, Mesto.naziv FROM (PoslovniPartner INNER JOIN FizickoLice ON (PoslovniPartner.PartnerID=FizickoLice.PartnerID)) INNER JOIN Mesto ON (Mesto.pttBroj=PoslovniPartner.ptt)";
        Statement statement = konekcija.createStatement();
        ResultSet rs = statement.executeQuery(upit);
        while (rs.next()) {
            FizickoLice fl = new FizickoLice();
            fl.setPartnerID(rs.getInt("PartnerID"));
            fl.setIme(rs.getString("ime"));
            fl.setPrezime(rs.getString("prezime"));
            fl.getAdresa().setNazivUlice(rs.getString("nazivUlice"));
            fl.getAdresa().setBroj(rs.getString("broj"));
            fl.getAdresa().getMesto().setPtt(rs.getInt("pttBroj"));
            fl.getAdresa().getMesto().setNaziv(rs.getString("naziv"));         
            fizickaLica.add(fl);
        }
        rs.close();
        statement.close();

        return fizickaLica;
    }

    public ArrayList<PravnoLice> vratiSvaPravnaLica() throws SQLException {

        ArrayList<PravnoLice> listaPL = new ArrayList<PravnoLice>();

        String upit = "SELECT PoslovniPartner.PartnerID, nazivUlice, Broj,  PravnoLice.Naziv, PravnoLice.PIB, PravnoLice.MaticniBroj, Mesto.PttBroj, Mesto.Naziv as nazivMesta "
                + "FROM Mesto INNER JOIN (PoslovniPartner INNER JOIN PravnoLice ON PoslovniPartner.PartnerID = PravnoLice.PartnerID) ON Mesto.PttBroj = PoslovniPartner.Ptt;";
        Statement statement = konekcija.createStatement();
        ResultSet rs = statement.executeQuery(upit);
        while (rs.next()) {
            PravnoLice pl = new PravnoLice();
            pl.setPartnerID(rs.getInt("PartnerID"));
            pl.setNaziv(rs.getString("naziv"));
            pl.setMaticniBroj(rs.getString("maticniBroj"));
            pl.setPib(rs.getString("PIB"));            
            pl.getAdresa().setBroj(rs.getString("broj"));
            pl.getAdresa().setNazivUlice(rs.getString("nazivUlice"));
            pl.getAdresa().getMesto().setPtt(rs.getInt("pttBroj"));
            pl.getAdresa().getMesto().setNaziv(rs.getString("nazivMesta"));
            listaPL.add(pl);
        }

        return listaPL;
    }

   
    public static void main(String[] args) throws ClassNotFoundException, SQLException {
        DBBroker dbbr = new DBBroker();
        dbbr.otvoriBazu();
        System.out.println("partneri:"+dbbr.vratiSvePoslovnePartnere());
    }
    
    
     public ArrayList<Proizvod> vratiSveProizvode() throws SQLException {

        ArrayList<Proizvod> listaP = new ArrayList<Proizvod>();

        String upit = "SELECT * FROM PROIZVOD";
        Statement statement = konekcija.createStatement();
        ResultSet rs = statement.executeQuery(upit);
        while (rs.next()) {

            Proizvod p = new Proizvod();
            p.setProizvodID(rs.getInt("ProizvodID"));
            p.setNaziv(rs.getString("Naziv"));
            p.setCena(rs.getDouble("cena"));
            listaP.add(p);
        }

        return listaP;
    }

    public void sacuvajOtpremnicu(Otpremnica o) throws SQLException {

        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
            
        String upit = "INSERT INTO OTPREMNICA VALUES"
                + "("+o.getOtpremnicaID()+","+sdf.format(o.getDatum())+","+o.getUkupanIznos()+","+o.getPartner().getPartnerID()+")";
        Statement naredba  = konekcija.createStatement();
        naredba.executeUpdate(upit);
        naredba.close();
        
    }

    public void sacuvajStavkuOtpremnice(StavkaOtpreminice stavkaOtpreminice) throws SQLException {
        String upit = "INSERT INTO STAVKAOTPREMNICE VALUES(?,?,?,?,?)";
        
        PreparedStatement naredba= konekcija.prepareStatement(upit);
        
        naredba.setInt(1, stavkaOtpreminice.getOtpremnica().getOtpremnicaID());
        naredba.setInt(2, stavkaOtpreminice.getRbStavke());
        naredba.setDouble(3, stavkaOtpreminice.getKolicina());
        naredba.setDouble(4, stavkaOtpreminice.getIznos());
        naredba.setInt(5, stavkaOtpreminice.getProizvod().getProizvodID());
        naredba.executeUpdate();
        
    }   
    
    
}
