/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package logic;

import db.DBBroker;
import domen.FizickoLice;
import domen.Mesto;
import domen.Otpremnica;
import domen.PoslovniPartner;
import domen.Proizvod;
import domen.StavkaOtpreminice;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author student1
 */
public class Kontroler {
    private ArrayList<Mesto> mesta;
    private ArrayList<PoslovniPartner> poslovniPartneri;
    
    DBBroker dbbr;
    private Kontroler(){
        dbbr = new DBBroker();
        mesta=new ArrayList<Mesto>();
        poslovniPartneri = new ArrayList<PoslovniPartner>();
        inicijalizujListuMesta();
    }
    private static Kontroler instance;
    public static Kontroler getInstance(){
        if(instance==null){
            instance=new Kontroler();
        }
        return instance;
    }
    
    public void dodajMesto(Mesto mesto) throws Exception{
        //mesta.add(mesto);
        DBBroker dbbr = new DBBroker();
        dbbr.otvoriBazu();
        dbbr.sacuvajMesto(mesto);
        dbbr.commitTransakcije();
        dbbr.zatvoriBazu();
        
    }
    
    public ArrayList<Mesto> vratiSvaMesta() throws Exception{
        //return mesta;
        
        DBBroker dbbr = new DBBroker();
        return dbbr.vratiSvaMesta();
    }
    
    public void dodajPoslovnogPartnera(PoslovniPartner poslovniPartner){
        poslovniPartneri.add(poslovniPartner);
    }
    
    
    public ArrayList<PoslovniPartner> vratiSvePoslovnePartnere() throws Exception {        
        
            dbbr.otvoriBazu();
            ArrayList<PoslovniPartner> listaPartnera =  dbbr.vratiSvePoslovnePartnere();
            dbbr.commitTransakcije();
            dbbr.zatvoriBazu();
            
            return listaPartnera;
       
    }
    
    public ArrayList<PoslovniPartner> vratiPoslovnePartnereIzMesta(Mesto mesto){
        ArrayList<PoslovniPartner> selektovaniPoslovniPartneri = new ArrayList<PoslovniPartner>();
        for (PoslovniPartner poslovniPartner : poslovniPartneri) {
            if(poslovniPartner.getAdresa().getMesto().equals(mesto)){
                selektovaniPoslovniPartneri.add(poslovniPartner);
            }
        }
        return selektovaniPoslovniPartneri;
    }
    
    public ArrayList<FizickoLice> vratiFizickaLica(){
        
        ArrayList<FizickoLice> listaFizickoLica = new ArrayList<>();
        
        
        for (int i = 0; i < poslovniPartneri.size(); i++) {
          
        try{
            FizickoLice fl = (FizickoLice) poslovniPartneri.get(i);
            listaFizickoLica.add(fl);
          }catch(Exception ex){
              //
          }  
        }
        return listaFizickoLica;
        
    }
    

    private void inicijalizujListuMesta() {
        mesta.add(new Mesto(11000, "Beograd"));
        mesta.add(new Mesto(11070, "Novi Beograd"));
        mesta.add(new Mesto(11080, "Zemun"));
        mesta.add(new Mesto(21000, "Novi Sad"));
    }
    
    
    public ArrayList<PoslovniPartner> vratiSvePartnere() throws Exception{
        
        dbbr.otvoriBazu();
        ArrayList<PoslovniPartner> lista =  dbbr.vratiSvePoslovnePartnere();
        dbbr.commitTransakcije();
        dbbr.zatvoriBazu();
        return lista;
        
    }
    
    
    public ArrayList<Proizvod> vratiSveProizvode() throws Exception{
        
        dbbr.otvoriBazu();
        ArrayList<Proizvod> lista =  dbbr.vratiSveProizvode();
        dbbr.commitTransakcije();
        dbbr.zatvoriBazu();
        return lista;
        
    }
    
    
    public void sacuvajOtpremnicu(Otpremnica o) throws Exception{
      
        try{
            dbbr.otvoriBazu();
            //dbbr.postaviID(o);
        dbbr.sacuvajOtpremnicu(o);
        ArrayList<StavkaOtpreminice> lista = o.getListaStavki();
        for (Iterator<StavkaOtpreminice> it = lista.iterator(); it.hasNext();) {
            StavkaOtpreminice stavkaOtpreminice = it.next();
            dbbr.sacuvajStavkuOtpremnice(stavkaOtpreminice);
        }
        dbbr.commitTransakcije();
        }catch(Exception ex){
            dbbr.rollbackTransakcije();
            throw ex;
        }
        
    }
    
}
