/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package baza;

import domen.FizickoLice;
import domen.Mesto;
import java.math.BigDecimal;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author student1
 */
public class DbKomunikacija {

    private Connection connection;

    public void ucitajDriver() throws Exception {
        Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
    }

    public void otvoriKonekciju() throws Exception {
        connection = DriverManager.getConnection("jdbc:odbc:D1");
        connection.setAutoCommit(false); // Zahteva eksplicitnu potvrdu transakcije
    }

    public void zatvoriKonekciju() throws Exception {
        connection.close();
    }
    
    public void commitTransakcije() throws Exception {
        try {
            connection.commit();
        } catch (SQLException ex) {
            ex.printStackTrace();
            throw new Exception("Transakcija nije potvrdjena!");
        }
    }
    
    public void rollbackTransakcije() throws Exception {
        try {
            connection.rollback();
        } catch (SQLException ex) {
            ex.printStackTrace();
            throw new Exception("Transakcija nije potvrdjena!");
        }
    }

    public void sacuvajMesto(Mesto mesto) throws Exception {
        try {
            String sql = "INSERT INTO Mesto VALUES (?,?)";
            PreparedStatement sqlNaredba = connection.prepareStatement(sql);
            //sqlNaredba.setLong(1, mesto.getPtt());
            sqlNaredba.setBigDecimal(1, new BigDecimal(mesto.getPtt()));
            sqlNaredba.setString(2, mesto.getNaziv());
            sqlNaredba.executeUpdate();
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new Exception("Mesto nije sacuvano!");
        }
    }

    public List<Mesto> vratiMesta() throws Exception {
        List<Mesto> listaMesta = new ArrayList<Mesto>();
        try {
            String sqlUpit = "SELECT * FROM Mesto";
            Statement sqlNaredba = connection.createStatement();
            ResultSet mesta = sqlNaredba.executeQuery(sqlUpit);

            while (mesta.next()) {
                long ptt = mesta.getLong(1);
                String naziv = mesta.getString("naziv");
                Mesto mesto = new Mesto(ptt, naziv);
                listaMesta.add(mesto);
            }
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new Exception("Greska pri ucitavanju mesta");
        }
        return listaMesta;
    }
    
    public void sacuvajFizickoLice(FizickoLice f) throws Exception {
        try {
            String sql = "INSERT INTO PoslovniPartner VALUES (?,?,?,?)";
            PreparedStatement sqlNaredba = connection.prepareStatement(sql);
            sqlNaredba.setInt(1, f.getPartnerID());
            sqlNaredba.setString(2, f.getAdresa().getNazivUlice());
            sqlNaredba.setString(3, f.getAdresa().getBrojUlice());
            sqlNaredba.setBigDecimal(4, new BigDecimal(f.getAdresa().getMesto().getPtt()));
            sqlNaredba.executeUpdate();
            sqlNaredba.close();
            
            sql = "INSERT INTO FizickoLice VALUES (?,?,?,?,?)";
            sqlNaredba = connection.prepareStatement(sql);
            sqlNaredba.setInt(1, f.getPartnerID());
            sqlNaredba.setString(2, f.getJmbg());
            sqlNaredba.setString(3, f.getIme());
            sqlNaredba.setString(4, f.getPrezime());
            sqlNaredba.setInt(5, f.getGodRodj());
            sqlNaredba.executeUpdate();
            sqlNaredba.close();
            
        } catch (SQLException ex) {
            ex.printStackTrace();
            throw new Exception("Fizicko lice nije sacuvano");
        }
        
    }
}
