/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package kontroler;

import baza.DBKomunikacija;
import domen.FizickoLice;
import domen.Mesto;
import java.util.List;

/**
 *
 * @author student1
 */
public class Kontroler {
    
    private DBKomunikacija db;
    private static Kontroler objekat;
    
    public static Kontroler vratiObjekat(){
        if(objekat==null)
            objekat = new Kontroler();
        return objekat;
    }

    private Kontroler() {
        db = new DBKomunikacija();
    }
    
    public void sacuvajMesto(Mesto m) throws Exception{
        db.ucitajDrajver();
        db.otvoriKonekciju();
        db.sacuvajMesto(m);
        db.commitTransakcije();
        db.zatvoriKonekciju();
    }
    
    public List<Mesto> vratiMesta() throws Exception{
        db.ucitajDrajver();
        db.otvoriKonekciju();
        List<Mesto> mesta = db.vratiMesta();
        db.commitTransakcije();
        db.zatvoriKonekciju();
        
        return mesta;
    }
    
    public void sacuvajFizickaLica(List<FizickoLice> lica) throws Exception {
        try {
            db.ucitajDrajver();
            db.otvoriKonekciju();
            for (FizickoLice f : lica) {
                db.sacuvajFizickoLice(f);
                System.out.println("Sacuvan " + f);
            }
            db.commitTransakcije();
            db.zatvoriKonekciju();
        } catch (Exception ex) {
            ex.printStackTrace();
            db.rollbackTransakcije();
            db.zatvoriKonekciju();
            throw ex;
        }
        
    }
    
    public static void main(String[] args) throws Exception{
        Kontroler.vratiObjekat().sacuvajMesto(new Mesto(18000, "Nis"));
        System.out.println(Kontroler.vratiObjekat().vratiMesta());
    }
    
}
