/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package kontroler;

import baza.DbKomunikacija;
import domen.FizickoLice;
import domen.Mesto;
import domen.PravnoLice;
import domen.Proizvod;
import java.util.List;

/**
 *
 * @author student1
 */
public class Kontroler {

    private DbKomunikacija db;
    private static Kontroler k;

    private Kontroler() {
        db = new DbKomunikacija();
    }

    public static Kontroler vratiObjekat() {
        if (k == null) {
            k = new Kontroler();
        }
        return k;
    }

    public void sacuvajMesto(Mesto mesto) throws Exception {
        db.ucitajDriver();
        db.otvoriKonekciju();
        db.sacuvajMesto(mesto);
        db.commitTransakcije();
        db.zatvoriKonekciju();
    }

    public List<Mesto> vratiMesta() throws Exception {
        db.ucitajDriver();
        db.otvoriKonekciju();
        List<Mesto> listaMesta = db.vratiMesta();
        db.commitTransakcije();
        db.zatvoriKonekciju();
        return listaMesta;
    }

    public void sacuvajFizickaLica(List<FizickoLice> lista) throws Exception {
        try {
            db.ucitajDriver();
            db.otvoriKonekciju();
            for (FizickoLice f : lista) {
                db.sacuvajFizickoLice(f);
                System.out.println("Sacuvao sam: " + f);
            }
            db.commitTransakcije();
            db.zatvoriKonekciju();
        } catch (Exception ex) {
            ex.printStackTrace();
            db.rollbackTransakcije();
            db.zatvoriKonekciju();
            throw ex;
        }
    }

    public List<Proizvod> vratiProizvode() throws Exception {
        db.ucitajDriver();
        db.otvoriKonekciju();
        List<Proizvod> listaProizvoda = db.vratiProizvode();
        db.commitTransakcije();
        db.zatvoriKonekciju();
        return listaProizvoda;
    }

    public List<FizickoLice> vratiFizickaLica() throws Exception {
        db.ucitajDriver();
        db.otvoriKonekciju();
        List<FizickoLice> listaFL = db.vratiFizickaLica();
        db.commitTransakcije();
        db.zatvoriKonekciju();
        return listaFL;
    }

    public List<PravnoLice> vratiPravnaLica() throws Exception {
        db.ucitajDriver();
        db.otvoriKonekciju();
        List<PravnoLice> listaPL = db.vratiPravnaLica();
        db.commitTransakcije();
        db.zatvoriKonekciju();
        return listaPL;
    }
}
