/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package forme.otpremnica.model;

import domen.Otpremnica;
import domen.Proizvod;
import domen.StavkaOtpremnice;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author student1
 */
public class ModelTabeleOtpremnica extends AbstractTableModel {
    private Otpremnica otpremnica;

    public ModelTabeleOtpremnica(Otpremnica otpremnica) {
        this.otpremnica = otpremnica;
    }

    @Override
    public int getRowCount() {
        if (otpremnica == null || otpremnica.getListaStavki() == null) {
            return 0;
        }
        return otpremnica.getListaStavki().size();
    }

    @Override
    public int getColumnCount() {
        return 4;
    }

    @Override
    public Object getValueAt(int rowIndex, int columnIndex) {
        StavkaOtpremnice stavka = otpremnica.getListaStavki().get(rowIndex);
        switch (columnIndex) {
            case 0: return stavka.getRbStavke();
            case 1: return stavka.getProizvod();
            case 2: return stavka.getKolicina();
            case 3: return stavka.getIznos();
            default: return "Greska!";
        }
    }
    @Override
    public String getColumnName(int column) {
        switch (column) {
            case 0: return "RB";
            case 1: return "Proizvod";
            case 2: return "Kolicina";
            case 3: return "Iznos";
            default: return "Greska";
        }
    }
    
    public void dodajRed() {
        otpremnica.dodajStavkuOtpremnice();
        fireTableDataChanged();
    }

    @Override
    public boolean isCellEditable(int rowIndex, int columnIndex) {
        if (columnIndex == 0 || columnIndex == 3) {
            return false;
        }
        return true;
    }

    @Override
    public void setValueAt(Object aValue, int rowIndex, int columnIndex) {
        StavkaOtpremnice stavka = otpremnica.getListaStavki().get(rowIndex);
        switch (columnIndex) {
            case 0: //Ovo ne moze da se promeni
                    break;
            case 1: stavka.setProizvod((Proizvod)aValue);
                    stavka.setIznos(stavka.getProizvod().getCena() * stavka.getKolicina());
                    fireTableCellUpdated(rowIndex, columnIndex + 2);
                    break;
            case 2: stavka.setKolicina(Integer.parseInt((String)aValue));
                    stavka.setIznos(stavka.getProizvod().getCena() * stavka.getKolicina());
                    fireTableCellUpdated(rowIndex, columnIndex + 1);
                    break;
            case 3: //Ovo ne moze da se promeni
                    break;
        }
    }
    
    public Otpremnica vratiOtpremnicu() {
        return otpremnica;
    }
    
    
    
}
