/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package forme.partner.model;

import domen.FizickoLice;
import domen.Mesto;
import java.util.List;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author Korisnik
 */
public class FizickoLiceModelTabele extends AbstractTableModel {

    private List<FizickoLice> fl;

    public FizickoLiceModelTabele(List<FizickoLice> l) {
        this.fl = l;
    }

    @Override
    public int getRowCount() {
        if (fl != null) {
            return fl.size();
        } else {
            return 0;
        }
    }

    @Override
    public int getColumnCount() {
        return 8;
    }

    @Override
    public Object getValueAt(int rowIndex, int columnIndex) {
        FizickoLice f = fl.get(rowIndex);
        switch (columnIndex) {
            case 0: return f.getPartnerID();
            case 1: return f.getJmbg();
            case 2: return f.getIme();
            case 3: return f.getPrezime();
            case 4: return f.getGodRodj();
            case 5: return f.getAdresa().getNazivUlice();
            case 6: return f.getAdresa().getBrojUlice();
            case 7: return f.getAdresa().getMesto();
            default: return "Greska!";
        }
    }

    @Override
    public String getColumnName(int column) {
        switch (column) {
            case 0: return "PartnerID";
            case 1: return "JMBG";
            case 2: return "Ime";
            case 3: return "Prezime";
            case 4: return "GodRodj";
            case 5: return "Ulica";
            case 6: return "Broj";
            case 7: return "Mesto";
            default: return "Greska!";
        }
    }

    @Override
    public boolean isCellEditable(int rowIndex, int columnIndex) {
        return true;
    }
    
    public void dodajRed(FizickoLice f) {
        fl.add(f);
        fireTableDataChanged();
    }
    
    public void obrisiRed(int red) {
        fl.remove(red);
        fireTableDataChanged();
    }
    
    public FizickoLice vratiRed(int red) {
        return fl.get(red);
    }
    
    public List<FizickoLice> vratiSve() {
        return fl;
    }

    @Override
    public void setValueAt(Object aValue, int rowIndex, int columnIndex) {
        FizickoLice f = fl.get(rowIndex);
        switch (columnIndex) {
            case 0: f.setPartnerID(Integer.parseInt((String)aValue)); break;
            case 1: f.setJmbg((String)aValue); break;
            case 2: f.setIme((String)aValue); break;
            case 3: f.setPrezime((String)aValue); break;
            case 4: f.setGodRodj(Integer.parseInt((String)aValue)); break;
            case 5: f.getAdresa().setNazivUlice((String)aValue); break;
            case 6: f.getAdresa().setBrojUlice((String)aValue); break;
            case 7: f.getAdresa().setMesto((Mesto)aValue); break;
        }
    }
 
}
