/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package server.komunikacija;

import domen.Mesto;
import domen.OpstiDomenskiObjekat;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutput;
import java.io.ObjectOutputStream;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.List;
import kontroler.Kontroler;
import transfer.TransferObjekat;

/**
 *
 * @author student1
 */
public class Komunikacija {

    private Socket soket;
    private boolean kraj = false;

    public void pokreniServer() throws IOException, ClassNotFoundException {
        ServerSocket serverSoket = new ServerSocket(9090);
        System.out.println("Server je pokrenut!");
        soket = serverSoket.accept();
        System.out.println("Klijent se povezao!");
        izvrsiOperacije();
    }

    public void izvrsiOperacije() throws IOException, ClassNotFoundException {
        while (!kraj) {
           
            ObjectInputStream input = new ObjectInputStream(soket.getInputStream());
            TransferObjekat toZahtev = (TransferObjekat) input.readObject();
            TransferObjekat toOdgovor = new TransferObjekat();
            try {
                switch (toZahtev.getOperacija()) {
                    case TransferObjekat.SACUVAJ_MESTO:
                        System.out.println("O: " + TransferObjekat.SACUVAJ_MESTO);
                        Mesto m = (Mesto) toZahtev.getParametar();
                        Kontroler.vratiObjekat().sacuvajMesto(m);
                        toOdgovor.setRezultat("Mesto je sacuvano!");
                        break;
                    case TransferObjekat.VRATI_SVA_MESTA: 
                        System.out.println("O: " + TransferObjekat.VRATI_SVA_MESTA);
                        List<OpstiDomenskiObjekat> lm = Kontroler.vratiObjekat().vratiMesta();
                        toOdgovor.setRezultat(lm);
                        break;
                }
            } catch (Exception e) {
                toOdgovor.setIzuzetak(e);
                toOdgovor.setRezultat("Mesto nije uspesno sacuvano!");
            }
            posaljiOdgovor(toOdgovor);
            
        }
    }

    private void posaljiOdgovor(TransferObjekat toOdgovor) throws IOException {
        ObjectOutputStream output = new ObjectOutputStream(soket.getOutputStream());
        output.writeObject(toOdgovor);
    }
    
    public static void main(String[] args) throws IOException, ClassNotFoundException {
        Komunikacija k = new Komunikacija();
        k.pokreniServer();
    }
}
