/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package kontroler;

import baza.DatabaseBroker;
import domen.FizickoLice;
import domen.Mesto;
import domen.OpstiDomenskiObjekat;
import domen.Otpremnica;
import domen.PravnoLice;
import domen.Proizvod;
import java.util.List;
import sistemskeOperacije.SOSacuvajMesto;

/**
 *
 * @author student1
 */
public class Kontroler {

    private DatabaseBroker db;
    private static Kontroler k;

    private Kontroler() {
        db = new DatabaseBroker();
    }

    public static Kontroler vratiObjekat() {
        if (k == null) {
            k = new Kontroler();
        }
        return k;
    }

    public void sacuvajMesto(Mesto mesto) throws Exception {
        SOSacuvajMesto so=new SOSacuvajMesto(mesto);
        so.izvrsenjeSO();
//        db.ucitajDriver();
//        db.otvoriKonekciju();
//        //db.sacuvajMesto(mesto);
//        db.sacuvaj(mesto);
//        db.commitTransakcije();
//        db.zatvoriKonekciju();
    }

    public List<OpstiDomenskiObjekat> vratiMesta() throws Exception {
        db.ucitajDriver();
        db.otvoriKonekciju();
        //List<Mesto> listaMesta = db.vratiMesta();
        List<OpstiDomenskiObjekat> listaMesta = db.vratiSve(new Mesto());
        db.commitTransakcije();
        db.zatvoriKonekciju();
        return listaMesta;
    }

    public void sacuvajFizickaLica(List<FizickoLice> lista) throws Exception {
        try {
            db.ucitajDriver();
            db.otvoriKonekciju();
            for (FizickoLice f : lista) {
                db.sacuvajFizickoLice(f);
                System.out.println("Sacuvao sam: " + f);
            }
            db.commitTransakcije();
            db.zatvoriKonekciju();
        } catch (Exception ex) {
            ex.printStackTrace();
            db.rollbackTransakcije();
            db.zatvoriKonekciju();
            throw ex;
        }
    }

    public List<Proizvod> vratiProizvode() throws Exception {
        db.ucitajDriver();
        db.otvoriKonekciju();
        List<Proizvod> listaProizvoda = db.vratiProizvode();
        db.commitTransakcije();
        db.zatvoriKonekciju();
        return listaProizvoda;
    }

    public List<FizickoLice> vratiFizickaLica() throws Exception {
        db.ucitajDriver();
        db.otvoriKonekciju();
        List<FizickoLice> listaFL = db.vratiFizickaLica();
        db.commitTransakcije();
        db.zatvoriKonekciju();
        return listaFL;
    }

    public List<PravnoLice> vratiPravnaLica() throws Exception {
        db.ucitajDriver();
        db.otvoriKonekciju();
        List<PravnoLice> listaPL = db.vratiPravnaLica();
        db.commitTransakcije();
        db.zatvoriKonekciju();
        return listaPL;
    }
    
    public void sacuvajOtpremnicu(Otpremnica otrpemnica) throws Exception {
        try {
            db.ucitajDriver();
            db.otvoriKonekciju();
            db.vratiSifruOtpremnice(otrpemnica);
            db.sacuvajOtpremnicu(otrpemnica);
            db.azurirajProizvod(otrpemnica);
            db.commitTransakcije();
            db.zatvoriKonekciju();
        } catch (Exception ex) {
            ex.printStackTrace();
            db.rollbackTransakcije();
            db.zatvoriKonekciju();
            throw ex;
        }
    }
}
