/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package server;

import domen.Mesto;
import domen.OpstiDomenskiObjekat;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import kontroler.Kontroler;
import transfer.TransferObjekat;

/**
 *
 * @author student1
 */
public class NitOpsluzivanjeKlijenta extends Thread{
    Socket socket;
    boolean kraj;

    public NitOpsluzivanjeKlijenta(Socket socket) {
        this.socket=socket;
    }
    
    public void run(){
        try {
            izvrsenjeOperacija();
        } catch (IOException ex) {
            Logger.getLogger(NitOpsluzivanjeKlijenta.class.getName()).log(Level.SEVERE, null, ex);
        } catch (ClassNotFoundException ex) {
            Logger.getLogger(NitOpsluzivanjeKlijenta.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
    
    public void izvrsenjeOperacija() throws IOException, ClassNotFoundException {
        while (!kraj) {
            ObjectInputStream inSocket = new ObjectInputStream(socket.getInputStream());
            TransferObjekat toZahtev = (TransferObjekat) inSocket.readObject();
            TransferObjekat toOdgovor = new TransferObjekat();
            try {
                switch (toZahtev.getOperacija()) {
                    case TransferObjekat.SACUVAJ_MESTO:
                        System.out.println("O: " + TransferObjekat.SACUVAJ_MESTO);
                        Mesto m = (Mesto) toZahtev.getParametar();
                        Kontroler.vratiObjekat().sacuvajMesto(m);
                        toOdgovor.setRezultat("Mesto je uspesno sacuvano!");
                        break;
                    case TransferObjekat.VRATI_SVA_MESTA:
                        System.out.println("O: " + TransferObjekat.VRATI_SVA_MESTA);
                        List<OpstiDomenskiObjekat> lm = Kontroler.vratiObjekat().vratiMesta();
                        toOdgovor.setRezultat(lm);
                        break;
                }
            } catch (Exception ex) {
                toOdgovor.setRezultat("Mesto nije sacuvano");
                toOdgovor.setIzuzetak(ex);
            }
            posaljiOdgovor(toOdgovor);
        }

    }

    private void posaljiOdgovor(TransferObjekat toOdgovor) throws IOException {
        ObjectOutputStream outSocket = new ObjectOutputStream(socket.getOutputStream());
        outSocket.writeObject(toOdgovor);
    }
}
