/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package kontroler;

import baza.DatabaseBroker;
import domen.FizickoLice;
import domen.Mesto;
import domen.OpstiDomenskiObjekat;
import domen.Otpremnica;
import domen.PravnoLice;
import domen.Proizvod;
import java.util.List;

/**
 *
 * @author student1
 */
public class Kontroler {

    private DatabaseBroker db;
    private static Kontroler objekat;

    public static Kontroler vratiObjekat() {
        if (objekat == null) {
            objekat = new Kontroler();
        }
        return objekat;
    }

    private Kontroler() {
        db = new DatabaseBroker();
    }

    public void sacuvajMesto(Mesto m) throws Exception {
        db.ucitajDrajver();
        db.otvoriKonekciju();
        //db.sacuvajMesto(m);
        db.sacuvaj(m);
        db.commitTransakcije();
        db.zatvoriKonekciju();
    }

    public List<OpstiDomenskiObjekat> vratiMesta() throws Exception {
        db.ucitajDrajver();
        db.otvoriKonekciju();
        List<OpstiDomenskiObjekat> mesta = db.vratiSve(new Mesto());
        db.commitTransakcije();
        db.zatvoriKonekciju();
        return mesta;
    }

    public void sacuvajFizickaLica(List<FizickoLice> lica) throws Exception {
        try {
            db.ucitajDrajver();
            db.otvoriKonekciju();
            for (FizickoLice f : lica) {
                db.sacuvajFizickoLice(f);
                System.out.println("Sacuvan " + f);
            }
            db.commitTransakcije();
            db.zatvoriKonekciju();
        } catch (Exception ex) {
            ex.printStackTrace();
            db.rollbackTransakcije();
            db.zatvoriKonekciju();
            throw ex;
        }

    }

    public List<Proizvod> vratiProizvode() throws Exception {
        db.ucitajDrajver();
        db.otvoriKonekciju();
        List<Proizvod> listaProizvoda = db.vratiProizvode();
        db.commitTransakcije();
        db.zatvoriKonekciju();
        return listaProizvoda;
    }

    public List<FizickoLice> vratiFizickaLica() throws Exception {
        db.ucitajDrajver();
        db.otvoriKonekciju();
        List<FizickoLice> listaFL = db.vratiFizickaLica();
        db.commitTransakcije();
        db.zatvoriKonekciju();
        return listaFL;
    }

    public List<PravnoLice> vratiPravnaLica() throws Exception {
        db.ucitajDrajver();
        db.otvoriKonekciju();
        List<PravnoLice> listaPL = db.vratiPravnaLica();
        db.commitTransakcije();
        db.zatvoriKonekciju();
        return listaPL;
    }
    
    
    public void sacuvajOtpremnicu(Otpremnica otpremnica) throws Exception {
        try {
            db.ucitajDrajver();
            db.otvoriKonekciju();
            db.vratiSifruOptremnice(otpremnica);
            db.sacuvajOtpremnicu(otpremnica);
            db.azurirajProizvod(otpremnica);
            db.commitTransakcije();
            db.zatvoriKonekciju();
        } catch (Exception ex) {
            ex.printStackTrace();
            db.rollbackTransakcije();
            db.zatvoriKonekciju();
            throw ex;
        }

    }
}
