/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package server.komunikacija;

import domen.Mesto;
import domen.OpstiDomenskiObjekat;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;
import java.util.List;
import kontroler.Kontroler;
import transfer.TransferObjekat;

/**
 *
 * @author student1
 */
public class NitKlijent extends Thread {
    private boolean kraj = false;
    private Socket soket;

    public NitKlijent(Socket soket) {
        this.soket = soket;
    }

    @Override
    public void run() {
        try {
            izvrsiOperacije();
        } catch(Exception ex) {
            ex.printStackTrace();
        }
        System.out.println("Nit zavrsila sa radom!");
    }

    public void izvrsiOperacije() throws IOException, ClassNotFoundException {
        while (!kraj) {

            ObjectInputStream input = new ObjectInputStream(soket.getInputStream());
            TransferObjekat toZahtev = (TransferObjekat) input.readObject();
            TransferObjekat toOdgovor = new TransferObjekat();
            try {
                switch (toZahtev.getOperacija()) {
                    case TransferObjekat.SACUVAJ_MESTO:
                        System.out.println("O: " + TransferObjekat.SACUVAJ_MESTO);
                        Mesto m = (Mesto) toZahtev.getParametar();
                        Kontroler.vratiObjekat().sacuvajMesto(m);
                        toOdgovor.setRezultat("Mesto je sacuvano!");
                        break;
                    case TransferObjekat.VRATI_SVA_MESTA:
                        System.out.println("O: " + TransferObjekat.VRATI_SVA_MESTA);
                        List<OpstiDomenskiObjekat> lm = Kontroler.vratiObjekat().vratiMesta();
                        toOdgovor.setRezultat(lm);
                        break;
                    case TransferObjekat.KRAJ_RADA:
                        kraj = true;
                        break;
                }
            } catch (Exception e) {
                toOdgovor.setIzuzetak(e);
                toOdgovor.setRezultat("Mesto nije uspesno sacuvano!");
            }
            posaljiOdgovor(toOdgovor);
        }
    }

    private void posaljiOdgovor(TransferObjekat toOdgovor) throws IOException {
        ObjectOutputStream output = new ObjectOutputStream(soket.getOutputStream());
        output.writeObject(toOdgovor);
    }
}
