/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package logic;

import db.DatabaseBroker;
import domain.FizickoLice;
import domain.Mesto;
import domain.PoslovniPartner;
import java.sql.SQLException;
import java.util.ArrayList;

/**
 *
 * @author student1
 */
public class Kontroler {
    //private ArrayList<Mesto> mesta;
    private ArrayList<PoslovniPartner> partneri;
    
    private DatabaseBroker dbbr;
    
    private Kontroler(){
        //mesta=new ArrayList<Mesto>();
        partneri=new ArrayList<PoslovniPartner>();
        dbbr=new DatabaseBroker();
    }
    
    private static Kontroler instance;
    public static Kontroler getInstance(){
        if(instance==null){
            instance=new Kontroler();
        }
        return instance;
    }
    
    public void ubaciMesto(Mesto mesto) throws ClassNotFoundException, SQLException{
        dbbr.otvoriBazu();
        //dbbr.ubaciMesto(mesto);
        dbbr.ubaciMestoBoljiNacin(mesto);
        dbbr.zatvoriBazu();
        //mesta.add(mesto);
    }
    
    public ArrayList<Mesto> vratiSvaMesta() throws ClassNotFoundException, SQLException{
        dbbr.otvoriBazu();
        ArrayList<Mesto> mesta= dbbr.vratiSvaMesta();
        dbbr.zatvoriBazu();
        return mesta;
    }
    
    public void ubaciPoslovnogPartnera(PoslovniPartner partner){
       partneri.add(partner);
    }
    public ArrayList<PoslovniPartner> vratiSvePartnere(){
        return this.partneri;
    }
    
    public ArrayList<PoslovniPartner> vratiPoslovnePartnereIzMesta(Mesto mesto){
        ArrayList<PoslovniPartner> poslovniPartneriIzMesta=new ArrayList<>();
        for (PoslovniPartner poslovniPartner : partneri) {
            if(poslovniPartner.getAdresa().getMesto().equals(mesto)){
                poslovniPartneriIzMesta.add(poslovniPartner);
            }
        }
        return poslovniPartneriIzMesta;
    }
    
    public ArrayList<FizickoLice> vratiSvaFizickaLica(){
        ArrayList<FizickoLice> fizickaLica=new ArrayList<>();
        for (PoslovniPartner poslovniPartner : partneri) {
            if(poslovniPartner instanceof FizickoLice){
                fizickaLica.add((FizickoLice)poslovniPartner);
            }
        }
        return fizickaLica;
    }
}
