/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package db;

import domain.Adresa;
import domain.FizickoLice;
import domain.Mesto;
import domain.PoslovniPartner;
import domain.PravnoLice;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;

/**
 *
 * @author student1
 */
public class DatabaseBroker {
    Connection connection;
    
    public void otvoriBazu() throws ClassNotFoundException, SQLException{
        Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
        String url="jdbc:odbc:partneri";
        String user="";
        String password="";
        connection=DriverManager.getConnection(url, user, password);
        connection.setAutoCommit(false);
    }
    
    public void zatvoriBazu() throws SQLException{
        connection.close();
    }
    
    public void commitTransakcije() throws SQLException{
        connection.commit();
    }
    
    public void rolBackTransakcije() throws SQLException{
        connection.rollback();
    }
            
    
    
    public void ubaciMesto(Mesto mesto) throws ClassNotFoundException, SQLException{      
        String upit="INSERT INTO mesto (pttbroj, naziv) VALUES ("+mesto.getPtt()+",'"+mesto.getNaziv()+"')";
        Statement statement=connection.createStatement();
        statement.executeUpdate(upit);
    }
    
    public void ubaciMestoBoljiNacin(Mesto mesto) throws ClassNotFoundException, SQLException{      
        String upit="INSERT INTO mesto (pttbroj, naziv) VALUES (?,?)";
        PreparedStatement statement=connection.prepareStatement(upit);
        statement.setInt(1, mesto.getPtt());
        statement.setString(2, mesto.getNaziv());
        statement.executeUpdate();
    }
    
    public ArrayList<Mesto> vratiSvaMesta() throws ClassNotFoundException, SQLException{
        ArrayList<Mesto> mesta=new ArrayList<>();
        
        String upit="SELECT pttbroj, naziv FROM mesto";
        Statement statement=connection.createStatement();
        ResultSet rs=statement.executeQuery(upit);
        while(rs.next()){
            int ptt=rs.getInt("pttbroj");
            String naziv=rs.getString("naziv");
            Mesto mesto=new Mesto(ptt, naziv);
            mesta.add(mesto);
        }
        rs.close();
        return mesta;
    }
    
    public void ubaciPoslovnogPartnera(PoslovniPartner poslovniPartner) throws SQLException{
        String upit="INSERT INTO poslovnipartner (poslovnipartnerID, ulica, broj, pttBroj, kontakt) VALUES (?,?,?,?,?)";
        PreparedStatement statement=connection.prepareStatement(upit);
        statement.setInt(1, poslovniPartner.getPoslovniPartnerID());
        statement.setString(2, poslovniPartner.getAdresa().getUlica());
        statement.setString(3, poslovniPartner.getAdresa().getBroj());
        statement.setInt(4, poslovniPartner.getAdresa().getMesto().getPtt());
        statement.setString(5, poslovniPartner.getKontakt());
        statement.executeUpdate();
        statement.close();
        if(poslovniPartner instanceof FizickoLice){
            ubaciFizickoLice((FizickoLice)poslovniPartner);
        }else{
            ubaciPravnoLice((PravnoLice)poslovniPartner);
        }
    }

    private void ubaciFizickoLice(FizickoLice fizickoLice) throws SQLException {
        String upit="INSERT INTO FizickoLice (poslovnipartnerID, ime, prezime, jmbg) VALUES (?,?,?,?)";
        PreparedStatement statement=connection.prepareStatement(upit);
        statement.setInt(1, fizickoLice.getPoslovniPartnerID());
        statement.setString(2, fizickoLice.getIme());
        statement.setString(3, fizickoLice.getPrezime());
        statement.setString(4, fizickoLice.getJmbg());
        statement.executeUpdate();
        statement.close();
    }

    private void ubaciPravnoLice(PravnoLice pravnoLice) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
    
    public ArrayList<PoslovniPartner> vratiSvePoslovnePartnere() throws SQLException{
        ArrayList<PoslovniPartner> partneri=new ArrayList<>();
        partneri.addAll(vratiSvaFizickaLica());
        //sve isto uraditi za pravna lica!!!
        
        return partneri;
    }
    
    public ArrayList<FizickoLice> vratiSvaFizickaLica() throws SQLException{
        ArrayList<FizickoLice> flica=new ArrayList<>();
        String upit="SELECT poslovniPartnerID, ulica, broj, Mesto.pttbroj,naziv, kontakt, ime, prezime, jmbg FROM PoslovniPartner INNER JOIN FizickoLice ON (PoslovniPartner.poslovnipartnerid=FizickoLice.poslovniPartnerID) INNER JOIN Mesto ON (mesto.pttBroj=poslovniPartner.pttbroj)";
        Statement statement=connection.createStatement();
        ResultSet rs=statement.executeQuery(upit);
        while(rs.next()){
            FizickoLice fl=new FizickoLice();
            fl.setPoslovniPartnerID(rs.getInt("poslovnipartnerid"));
            fl.setAdresa(new Adresa(rs.getString("ulica"), rs.getString("broj"), new Mesto(rs.getInt("pttBroj"), rs.getString("naziv"))));
            fl.setKontakt(rs.getString("kontakt"));
            fl.setIme(rs.getString("ime"));
            fl.setPrezime(rs.getString("prezime"));
            fl.setJmbg(rs.getString("jmbg"));
            flica.add(fl);
        }
        rs.close();
        statement.close();
        return flica;
    }
    
}
