/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package logic;

import db.DatabaseBroker;
import domain.FizickoLice;
import domain.Mesto;
import domain.PoslovniPartner;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author student1
 */
public class Kontroler {
    //private ArrayList<Mesto> mesta;
    //private ArrayList<PoslovniPartner> partneri;
    
    private DatabaseBroker dbbr;
    
    private Kontroler(){
        //mesta=new ArrayList<Mesto>();
        //partneri=new ArrayList<PoslovniPartner>();
        dbbr=new DatabaseBroker();
    }
    
    private static Kontroler instance;
    public static Kontroler getInstance(){
        if(instance==null){
            instance=new Kontroler();
        }
        return instance;
    }
    
    public void ubaciMesto(Mesto mesto) throws ClassNotFoundException, SQLException{
        dbbr.otvoriBazu();
        //dbbr.ubaciMesto(mesto);
        dbbr.ubaciMestoBoljiNacin(mesto);
        dbbr.zatvoriBazu();
        //mesta.add(mesto);
    }
    
    public ArrayList<Mesto> vratiSvaMesta() throws ClassNotFoundException, SQLException{
        dbbr.otvoriBazu();
        ArrayList<Mesto> mesta= dbbr.vratiSvaMesta();
        dbbr.commitTransakcije();
        dbbr.zatvoriBazu();
        return mesta;
    }
    
    public void ubaciPoslovnogPartnera(PoslovniPartner partner) throws ClassNotFoundException, SQLException{
       dbbr.otvoriBazu();
       dbbr.ubaciPoslovnogPartnera(partner);
       dbbr.zatvoriBazu();
    }
    public ArrayList<PoslovniPartner> vratiSvePartnere() throws ClassNotFoundException, SQLException{
        dbbr.otvoriBazu();
        ArrayList<PoslovniPartner> partneri=dbbr.vratiSvePoslovnePartnere();
        dbbr.zatvoriBazu();
        return partneri;
    }
    
//    public ArrayList<PoslovniPartner> vratiPoslovnePartnereIzMesta(Mesto mesto){
//        ArrayList<PoslovniPartner> poslovniPartneriIzMesta=new ArrayList<>();
//        for (PoslovniPartner poslovniPartner : partneri) {
//            if(poslovniPartner.getAdresa().getMesto().equals(mesto)){
//                poslovniPartneriIzMesta.add(poslovniPartner);
//            }
//        }
//        return poslovniPartneriIzMesta;
//    }
    
    public ArrayList<FizickoLice> vratiSvaFizickaLica() throws ClassNotFoundException, SQLException{
        dbbr.otvoriBazu();
        ArrayList<FizickoLice> partneri=dbbr.vratiSvaFizickaLica();
        dbbr.zatvoriBazu();
        return partneri;
    }
    
    public void ubaciPoslovnePartnere(ArrayList<FizickoLice> partnri) throws SQLException {
        try {
            dbbr.otvoriBazu();
            for (FizickoLice poslovniPartner : partnri) {
                dbbr.ubaciPoslovnogPartnera(poslovniPartner);
            }
            dbbr.commitTransakcije();
            dbbr.zatvoriBazu();
        } catch (Exception ex) {
            dbbr.rolBackTransakcije();
        }
            
    }
    
}
