/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package logic;

import db.DatabaseBroker;
import domain.FizickoLice;
import domain.Mesto;
import domain.PoslovniPartner;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author student1
 */
public class Kontroler {
    DatabaseBroker dbbr;
    
    //private ArrayList<PoslovniPartner> poslovniPartneri;
    
    private static Kontroler instance;
    public static Kontroler getInstance(){
        if(instance==null){
            instance=new Kontroler();
        }
        return instance;
    }
    
    private Kontroler(){
        dbbr=new DatabaseBroker();
        //poslovniPartneri = new ArrayList<>();
    }
    
    public void dodajMesto(Mesto mesto) throws ClassNotFoundException, SQLException{
        dbbr.otvoriBazu();
        dbbr.ubaciMestoBoljiNacin(mesto);
        dbbr.commitTransakcije();
        dbbr.zatvoriBazu();
    }
    
    public ArrayList<Mesto> vratiSvaMesta() throws ClassNotFoundException, SQLException{
        dbbr.otvoriBazu();
        ArrayList<Mesto> mesta=dbbr.vratiSvaMesta();
        dbbr.commitTransakcije();
        dbbr.zatvoriBazu();
        return mesta;
    }
    
    public void dodajPartnera(PoslovniPartner p) throws ClassNotFoundException, SQLException{
        dbbr.otvoriBazu();
        dbbr.ubaciPoslovnogPartnera(p);
        dbbr.commitTransakcije();
        dbbr.zatvoriBazu();
    }
    
    public ArrayList<PoslovniPartner> vratiSvePartnere() throws ClassNotFoundException, SQLException{
        dbbr.otvoriBazu();
        ArrayList<PoslovniPartner> partneri=dbbr.vratiSvePoslovnePartnere();
        dbbr.commitTransakcije();
        dbbr.zatvoriBazu();
        return partneri;
    }
    
    public ArrayList<PoslovniPartner> vratiPoslovnePartnereIzMesta(Mesto mesto){
        ArrayList<PoslovniPartner> poslovniPartneriIzMesta=new ArrayList<>();
//        for (PoslovniPartner poslovniPartner : poslovniPartneri) {
//            if(poslovniPartner.getAdresa().getMesto().equals(mesto)){
//                poslovniPartneriIzMesta.add(poslovniPartner);
//            }
//        }
        return poslovniPartneriIzMesta;
    }
    
    public ArrayList<FizickoLice> vratiSvaFizickaLica() throws ClassNotFoundException, SQLException{
        dbbr.otvoriBazu();
        ArrayList<FizickoLice> fizickaLica=dbbr.vratiSvaFizickaLica();
        dbbr.commitTransakcije();
        dbbr.zatvoriBazu();
        return fizickaLica;
    }
    
    public void sacuvajFizickaLica(ArrayList<FizickoLice> fizickaLica) throws SQLException, ClassNotFoundException {
        dbbr.otvoriBazu();
        try {
            
            for (FizickoLice fizickoLice : fizickaLica) {
                dbbr.ubaciPoslovnogPartnera(fizickoLice);
            }
            dbbr.commitTransakcije();
            
        } catch (Exception ex) {
            dbbr.rollbackTransakcije();
        } 
        dbbr.zatvoriBazu();
    }
    
}
