/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package logic;

import db.DatabaseBroker;
import domain.FizickoLice;
import domain.Mesto;
import domain.Otpremnica;
import domain.PoslovniPartner;
import domain.Proizvod;
import domain.StavkaOtpremnice;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author student1
 */
public class Kontroler {

    DatabaseBroker dbbr;

    //ArrayList<PoslovniPartner> poslovniPartneri;
    private Kontroler() {
        dbbr = new DatabaseBroker();
        //poslovniPartneri = new ArrayList<>();
    }
    private static Kontroler instance;

    public static Kontroler getInstance() {
        if (instance == null) {
            instance = new Kontroler();
        }
        return instance;
    }

    public void ubaciMesto(Mesto mesto) throws ClassNotFoundException, SQLException {
        dbbr.otvoriBazu();
        dbbr.ubaciMestoBoljiNacin(mesto);
        dbbr.commitTransakcije();
        dbbr.zatvoriBazu();
    }

    public ArrayList<Mesto> vratiSvaMesta() throws ClassNotFoundException, SQLException {
        dbbr.otvoriBazu();
        ArrayList<Mesto> mesta = dbbr.vratiSvaMesta();
        dbbr.commitTransakcije();
        dbbr.zatvoriBazu();
        return mesta;
    }

    public void ubaciPoslovnogPartnera(PoslovniPartner poslovniPartner) throws ClassNotFoundException, SQLException {
        dbbr.otvoriBazu();
        dbbr.ubaciPoslovnogPartnera(poslovniPartner);
        dbbr.commitTransakcije();
        dbbr.zatvoriBazu();
    }

    public ArrayList<PoslovniPartner> vratiSvePoslovnePartnere() throws ClassNotFoundException, SQLException {
        dbbr.otvoriBazu();
        ArrayList<PoslovniPartner> partneri = dbbr.vratiSvePoslovnePartnere();
        dbbr.commitTransakcije();
        dbbr.zatvoriBazu();
        return partneri;

    }

    public ArrayList<PoslovniPartner> vratiPoslovnePartnereIzMesta(Mesto mesto) {
        ArrayList<PoslovniPartner> poslovniPartneriIzMesta = new ArrayList<>();
//        for (PoslovniPartner poslovniPartner : poslovniPartneri) {
//            if(poslovniPartner.getAdresa().getMesto().equals(mesto)){
//                poslovniPartneriIzMesta.add(poslovniPartner);
//            }
//            
//        }
        return poslovniPartneriIzMesta;
    }

    public ArrayList<FizickoLice> vratiSvaFizickaLica() throws ClassNotFoundException, SQLException {
        dbbr.otvoriBazu();
        ArrayList<FizickoLice> fizickaLica = dbbr.vratiSvaFizickaLica();
        dbbr.commitTransakcije();
        dbbr.zatvoriBazu();

        return fizickaLica;
    }

    public void sacuvajFizickaLica(ArrayList<FizickoLice> vratiFizickaLica) throws ClassNotFoundException, SQLException {
        dbbr.otvoriBazu();
        try {
            for (FizickoLice fizickoLice : vratiFizickaLica) {
                dbbr.ubaciPoslovnogPartnera(fizickoLice);
            }
            dbbr.commitTransakcije();
        } catch (SQLException ex) {
            dbbr.rollbackTransakcije();
            throw ex;
        }
        dbbr.zatvoriBazu();
    }

    public ArrayList<Proizvod> vratiSveProizvode() throws ClassNotFoundException, SQLException {
        ArrayList<Proizvod> proizvodi=new ArrayList<>();
        dbbr.otvoriBazu();
        try {
            proizvodi=dbbr.vratiSveProizvode();
            dbbr.commitTransakcije();
        } catch (SQLException ex) {
            Logger.getLogger(Kontroler.class.getName()).log(Level.SEVERE, null, ex);
            dbbr.rollbackTransakcije();
            throw ex;
        }
        dbbr.zatvoriBazu();
        return proizvodi;
    }

    public void sacuvajOtpremnicu(Otpremnica otpremnica) throws ClassNotFoundException, SQLException {
        dbbr.otvoriBazu();
        try {
            dbbr.ubaciOtpremnicu(otpremnica);
            for (StavkaOtpremnice so : otpremnica.getListaStavki()) {
                int novoStanje=dbbr.vratiNovoStajneNaZalihama(so.getKolicina(), so.getProizvod());
                if(novoStanje>=0){
                    dbbr.ubaciStavkuOtpremnice(otpremnica, so);
                    so.getProizvod().setStanjeNaZalihama(novoStanje);
                    dbbr.izmeniProizvod(so.getProizvod());
                }
            }
            dbbr.commitTransakcije();
        } catch (SQLException ex) {
            Logger.getLogger(Kontroler.class.getName()).log(Level.SEVERE, null, ex);
            dbbr.rollbackTransakcije();
            throw ex;
        }
    }

    
}
