/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package view.model;

import domain.Otpremnica;
import domain.Proizvod;
import domain.StavkaOtpremnice;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author student1
 */
public class TableModelStavkaOtpremnice extends AbstractTableModel{
    
    Otpremnica otpremnica;
    String[] columnNames=new String[]{"RB","Proizvod", "Kolicina", "Iznos"};

    public TableModelStavkaOtpremnice(Otpremnica otpremnica) {
        this.otpremnica=otpremnica;
    }

    
    
    @Override
    public String getColumnName(int column) {
        return columnNames[column];
    }
    
    
    
    @Override
    public int getRowCount() {
        return otpremnica.getListaStavki().size();
    }

    @Override
    public int getColumnCount() {
        return columnNames.length;
    }

    @Override
    public Object getValueAt(int rowIndex, int columnIndex) {
        StavkaOtpremnice so=otpremnica.getListaStavki().get(rowIndex);
        switch(columnIndex){
            case 0: return so.getRbStavke();
            case 1: return so.getProizvod();
            case 2: return so.getKolicina();
            case 3: return so.getIznos();
            default:return null;
        }
    }

    @Override
    public void setValueAt(Object aValue, int rowIndex, int columnIndex) {
        StavkaOtpremnice so=otpremnica.getListaStavki().get(rowIndex);
        switch(columnIndex){
            case 0: so.setRbStavke(Integer.parseInt(aValue.toString())); break;
            case 1: so.setProizvod((Proizvod)aValue); so.setIznos(so.getKolicina()*so.getProizvod().getCena());fireTableDataChanged();break;
            case 2: so.setKolicina(Integer.parseInt(aValue.toString())); so.setIznos(so.getKolicina()*so.getProizvod().getCena());fireTableDataChanged();break;
            case 3: so.setIznos(Double.parseDouble(aValue.toString())); break;
        }
    }

    @Override
    public boolean isCellEditable(int rowIndex, int columnIndex) {
        if(columnIndex==0 || columnIndex==3) return false;
        return true;
    }
    
    public void dodajStavkuOtpremnice(){
        otpremnica.dodajStavkuOtpremnice();
        fireTableDataChanged();
    }
    
    public double  vratiUkupanIznosOtpemnice(){
        double ukupanIznos=0;
        for (StavkaOtpremnice so : otpremnica.getListaStavki()) {
            ukupanIznos+=so.getIznos();
        }
        return ukupanIznos;
    }
    
    public Otpremnica vratiOtpremnicu(){
        return otpremnica;
    }
    
    
    
    
    
}
