/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package db;

import domain.FizickoLice;
import domain.Mesto;
import domain.PoslovniPartner;
import domain.PravnoLice;
import domain.Proizvod;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

/**
 *
 * @author student1
 */
public class DatabaseBroker {

    Connection connection;

    public void otvoriBazu() throws ClassNotFoundException, SQLException {
        Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
        String url = "jdbc:odbc:partneri";
        String user = "";
        String password = "";
        connection = DriverManager.getConnection(url, user, password);
        connection.setAutoCommit(false);
    }

    public void zatvoriBazu() throws SQLException {
        connection.close();
    }

    public void commitTransakcije() throws SQLException {
        connection.commit();
    }

    public void rollbackTransakcije() throws SQLException {
        connection.rollback();
    }

    public void ubaciMesto(Mesto mesto) throws ClassNotFoundException, SQLException {
        String upit = "INSERT INTO mesto (pttbroj,naziv) VALUES (" + mesto.getPtt() + ",'" + mesto.getNaziv() + "')";
        Statement statement = connection.createStatement();
        statement.executeUpdate(upit);
        statement.close();
    }

    public void ubaciMestoBoljiNacin(Mesto mesto) throws ClassNotFoundException, SQLException {
        String upit = "INSERT INTO mesto (pttbroj,naziv) VALUES (?,?)";
        PreparedStatement statement = connection.prepareStatement(upit);
        statement.setInt(1, mesto.getPtt());
        statement.setString(2, mesto.getNaziv());
        statement.executeUpdate();
        statement.close();
    }

    public ArrayList<Mesto> vratiSvaMesta() throws SQLException {
        ArrayList<Mesto> mesta = new ArrayList<>();
        String upit = "SELECT pttbroj, naziv FROM Mesto";
        Statement statement = connection.createStatement();
        ResultSet rs = statement.executeQuery(upit);
        while (rs.next()) {
            int ptt = rs.getInt("pttbroj");
            String naziv = rs.getString("naziv");
            Mesto mesto = new Mesto(ptt, naziv);
            mesta.add(mesto);
        }
        rs.close();
        statement.close();
        return mesta;
    }

    public void ubaciPoslovnogPartnera(PoslovniPartner poslovniPartner) throws SQLException {
        String upit = "INSERT INTO PoslovniPartner (poslovniPartnerID, ulica, broj, pttbroj, kontakt) VALUES (?,?,?,?,?)";
        PreparedStatement statement = connection.prepareStatement(upit);
        statement.setInt(1, poslovniPartner.getPoslovniPartnerID());
        statement.setString(2, poslovniPartner.getAdresa().getUlica());
        statement.setString(3, poslovniPartner.getAdresa().getBroj());
        statement.setInt(4, poslovniPartner.getAdresa().getMesto().getPtt());
        statement.setString(5, poslovniPartner.getKontakt());
        statement.executeUpdate();

        if (poslovniPartner instanceof FizickoLice) {
            ubaciFizickoLice((FizickoLice) poslovniPartner);
        } else {
            ubaciPravnoLice((PravnoLice) poslovniPartner);
        }

        statement.close();
    }

    private void ubaciFizickoLice(FizickoLice fizickoLice) throws SQLException {
        String upit = "INSERT INTO FizickoLice (poslovniPartnerID, ime, prezime, jmbg) VALUES (?,?,?,?)";
        PreparedStatement statement = connection.prepareStatement(upit);
        statement.setInt(1, fizickoLice.getPoslovniPartnerID());
        statement.setString(2, fizickoLice.getIme());
        statement.setString(3, fizickoLice.getPrezime());
        statement.setString(4, fizickoLice.getJmbg());
        statement.executeUpdate();
        statement.close();
    }

    private void ubaciPravnoLice(PravnoLice pravnoLice) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    public ArrayList<PoslovniPartner> vratiSvePoslovnePartnere() throws SQLException {
        ArrayList<PoslovniPartner> partneri = new ArrayList<>();

        partneri.addAll(vratiSvaFizickaLica());
        //partneri.addAll(vratiSvaPravnaLica());

        return partneri;
    }

    public ArrayList<FizickoLice> vratiSvaFizickaLica() throws SQLException {
        ArrayList<FizickoLice> fizickaLica = new ArrayList<>();
        String upit = "SELECT PoslovniPartner.poslovniPartnerID, ime, prezime, jmbg, ulica, broj, Mesto.pttBroj, Mesto.naziv, kontakt FROM (PoslovniPartner INNER JOIN FizickoLice ON (PoslovniPartner.poslovniPartnerID=FizickoLice.poslovniPartnerID)) INNER JOIN Mesto ON (Mesto.pttBroj=PoslovniPartner.pttBroj)";
        Statement statement = connection.createStatement();
        ResultSet rs = statement.executeQuery(upit);
        while (rs.next()) {
            FizickoLice fl = new FizickoLice();
            fl.setPoslovniPartnerID(rs.getInt("poslovniPartnerID"));
            fl.setIme(rs.getString("ime"));
            fl.setPrezime(rs.getString("prezime"));
            fl.getAdresa().setUlica(rs.getString("Ulica"));
            fl.getAdresa().setBroj(rs.getString("broj"));
            fl.getAdresa().getMesto().setPtt(rs.getInt("pttBroj"));
            fl.getAdresa().getMesto().setNaziv(rs.getString("naziv"));
            fl.setKontakt(rs.getString("kontakt"));
            fizickaLica.add(fl);
        }
        rs.close();
        statement.close();

        return fizickaLica;
    }

    private Collection<? extends PoslovniPartner> vratiSvaPravnaLica() {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    public ArrayList<Proizvod> vratiSveProizvode() throws SQLException {
        ArrayList<Proizvod> proizvodi = new ArrayList<Proizvod>();
        String upit = "SELECT proizvodID, naziv, cena, stanjeNaZalihama FROM Proizvod";
        Statement statement = connection.createStatement();
        ResultSet rs = statement.executeQuery(upit);
        while (rs.next()) {
            int sifraProizvoda = rs.getInt("ProizvodID");
            String naziv = rs.getString("Naziv");
            double cena = rs.getDouble("Cena");
            int stanjeNaZalihama = rs.getInt("StanjeNaZalihama");
            Proizvod p = new Proizvod(sifraProizvoda, naziv, cena, stanjeNaZalihama);
            proizvodi.add(p);
        }

        return proizvodi;
    }
}
