/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package db;

import domain.FizickoLice;
import domain.Mesto;
import domain.Otpremnica;
import domain.PoslovniPartner;
import domain.PravnoLice;
import domain.Proizvod;
import domain.StavkaOtpremnice;
import java.sql.Connection;
import java.sql.Date;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.Collection;

/**
 *
 * @author student1
 */
public class DatabaseBroker {
    Connection connection;
    public void otvoriBazu() throws ClassNotFoundException, SQLException{
        Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
        String url="jdbc:odbc:partneri";
        String user="";
        String password="";
        connection=DriverManager.getConnection(url, user, password);
        connection.setAutoCommit(false);
    }
        
    public void zatvoriBazu() throws SQLException{
        connection.close();
    }
    
    public void commitTransakcije() throws SQLException{
        connection.commit();
    }
    
    public void rollbackTransakcije() throws SQLException{
        connection.rollback();
    }
    
    public void ubaciMesto(Mesto mesto) throws ClassNotFoundException, SQLException{      
        String upit="INSERT INTO mesto (pttbroj,naziv) VALUES ("+mesto.getPtt()+",'"+mesto.getNaziv()+"')";
        Statement statement=connection.createStatement();
        statement.executeUpdate(upit);
        statement.close();     
    }
    
    public void ubaciMestoBoljiNacin(Mesto mesto) throws ClassNotFoundException, SQLException{      
        String upit="INSERT INTO mesto (pttbroj,naziv) VALUES (?,?)";
        PreparedStatement statement=connection.prepareStatement(upit);
        statement.setInt(1, mesto.getPtt());
        statement.setString(2, mesto.getNaziv());
        statement.executeUpdate();
        statement.close();     
    }
    
    public ArrayList<Mesto> vratiSvaMesta() throws SQLException{
        ArrayList<Mesto> mesta=new ArrayList<>();
        String upit="SELECT pttbroj, naziv FROM Mesto";
        Statement statement=connection.createStatement();
        ResultSet rs=statement.executeQuery(upit);
        while(rs.next()){
            int ptt=rs.getInt("pttbroj");
            String naziv=rs.getString("naziv");
            Mesto mesto=new Mesto(ptt, naziv);
            mesta.add(mesto);
        }
        rs.close();
        statement.close();
        return mesta;
    }
    
    public void ubaciPoslovnogPartnera(PoslovniPartner poslovniPartner) throws SQLException{
        String upit="INSERT INTO PoslovniPartner (poslovniPartnerID, ulica, broj, pttbroj, kontakt) VALUES (?,?,?,?,?)";
        PreparedStatement statement=connection.prepareStatement(upit);
        statement.setInt(1, poslovniPartner.getPoslovniPartnerID());
        statement.setString(2, poslovniPartner.getAdresa().getUlica());
        statement.setString(3, poslovniPartner.getAdresa().getBroj());
        statement.setInt(4, poslovniPartner.getAdresa().getMesto().getPtt());
        statement.setString(5, poslovniPartner.getKontakt());
        statement.executeUpdate();
        
        if(poslovniPartner instanceof FizickoLice){
            ubaciFizickoLice((FizickoLice)poslovniPartner);
        }else{
            ubaciPravnoLice((PravnoLice)poslovniPartner);
        }
        
        statement.close();
    }

    private void ubaciFizickoLice(FizickoLice fizickoLice) throws SQLException {
        String upit="INSERT INTO FizickoLice (poslovniPartnerID, ime, prezime, jmbg) VALUES (?,?,?,?)";
        PreparedStatement statement=connection.prepareStatement(upit);
        statement.setInt(1, fizickoLice.getPoslovniPartnerID());
        statement.setString(2, fizickoLice.getIme());
        statement.setString(3, fizickoLice.getPrezime());
        statement.setString(4, fizickoLice.getJmbg());
        statement.executeUpdate();
        statement.close();
    }

    private void ubaciPravnoLice(PravnoLice pravnoLice) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
    
    public ArrayList<PoslovniPartner> vratiSvePoslovnePartnere() throws SQLException{
        ArrayList<PoslovniPartner> partneri=new ArrayList<>();
        
        partneri.addAll(vratiSvaFizickaLica());
        //partneri.addAll(vratiSvaPravnaLica());
        
        return partneri;
    }

    public ArrayList<FizickoLice> vratiSvaFizickaLica() throws SQLException {
        ArrayList<FizickoLice> fizickaLica=new ArrayList<>();
        String upit="SELECT PoslovniPartner.poslovniPartnerID, ime, prezime, jmbg, ulica, broj, Mesto.pttBroj, Mesto.naziv, kontakt FROM (PoslovniPartner INNER JOIN FizickoLice ON (PoslovniPartner.poslovniPartnerID=FizickoLice.poslovniPartnerID)) INNER JOIN Mesto ON (Mesto.pttBroj=PoslovniPartner.pttBroj)";
        Statement statement=connection.createStatement();
        ResultSet rs=statement.executeQuery(upit);
        while(rs.next()){
            FizickoLice fl=new FizickoLice();
            fl.setPoslovniPartnerID(rs.getInt("poslovniPartnerID"));
            fl.setIme(rs.getString("ime"));
            fl.setPrezime(rs.getString("prezime"));
            fl.getAdresa().setUlica(rs.getString("Ulica"));
            fl.getAdresa().setBroj(rs.getString("broj"));
            fl.getAdresa().getMesto().setPtt(rs.getInt("pttBroj"));
            fl.getAdresa().getMesto().setNaziv(rs.getString("naziv"));
            fl.setKontakt(rs.getString("kontakt"));
            fizickaLica.add(fl);
        }
        rs.close();
        statement.close();
        
        return fizickaLica;
    }

    private Collection<? extends PoslovniPartner> vratiSvaPravnaLica() {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
    
    public ArrayList<Proizvod> vratiSveProizvode() throws SQLException{
        ArrayList<Proizvod> proizvodi=new ArrayList<>();
        String upit="SELECT proizvodID, naziv, cena, stanjeNaZalihama FROM Proizvod";
        Statement statement=connection.createStatement();
        ResultSet rs=statement.executeQuery(upit);
        while(rs.next()){
            Proizvod p=new Proizvod();
            p.setProizvodID(rs.getInt("proizvodID"));
            p.setNaziv(rs.getString("naziv"));
            p.setCena(rs.getDouble("cena"));
            p.setStanjeNaZalihama(rs.getInt("stanjeNaZalihama"));
            proizvodi.add(p);
        }
        rs.close();
        statement.close();
        return proizvodi;
    }
    
    public void sacuvajOtpremnicu(Otpremnica otpremnica) throws SQLException{
        String upit="INSERT INTO Otpremnica (otpremnicaID, datum, ukupanIznos, poslovniPartnerID) VALUES (?,?,?,?)";
        PreparedStatement statement=connection.prepareStatement(upit);
        statement.setInt(1, otpremnica.getOtpremnicaID());
        Date datum=new Date(otpremnica.getDatum().getTime());
        statement.setDate(2, datum);
        statement.setDouble(3, otpremnica.getUkupanIznos());
        statement.setInt(4, otpremnica.getPoslovniPartner().getPoslovniPartnerID());
        statement.executeUpdate();
        statement.close();
    }
    
    public void sacuvajStavkuOtpremnice(Otpremnica otpremnica, StavkaOtpremnice stavkaOtpremnice) throws SQLException{
        String upit="INSERT INTO StavkaOtpremnice (otpremnicaID, RBStavke, proizvodID, kolicina, iznos) VALUES (?,?,?,?,?)";
        PreparedStatement statement=connection.prepareStatement(upit);
        statement.setInt(1, otpremnica.getOtpremnicaID());
        statement.setInt(2, stavkaOtpremnice.getRbStavke());
        statement.setInt(3, stavkaOtpremnice.getProizvod().getProizvodID());
        statement.setInt(4, stavkaOtpremnice.getKolicina());
        statement.setDouble(5, stavkaOtpremnice.getIznos());
        statement.executeUpdate();
        statement.close();
    }
    
    public int vratiNovoStanjeNaZalihama(int kolicina, Proizvod proizvod) throws SQLException{
        int novoStanje=-1;
        String upit="SELECT (stanjeNaZalihama - ?) AS stanje FROM Proizvod WHERE proizvodID=?";
        PreparedStatement statement=connection.prepareStatement(upit);
        statement.setInt(1, kolicina);
        statement.setInt(2, proizvod.getProizvodID());
        ResultSet rs=statement.executeQuery();
        if(rs.next()){
            novoStanje=rs.getInt("stanje");
        }
        rs.close();
        statement.close();
        return novoStanje;
    }
    
    public void izmeniProizvod(Proizvod proizvod) throws SQLException{
        String upit="UPDATE Proizvod SET naziv=?, cena=?, stanjeNaZalihama=? WHERE proizvodID=?";
        PreparedStatement statement=connection.prepareStatement(upit);
        statement.setString(1, proizvod.getNaziv());
        statement.setDouble(2, proizvod.getCena());
        statement.setInt(3, proizvod.getStanjeNaZalihama());
        statement.setInt(4, proizvod.getProizvodID());
        statement.executeUpdate();
        statement.close();
    }
    
}
