/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package view.model;

import domain.FizickoLice;
import domain.Mesto;
import java.util.ArrayList;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author student1
 */
public class TableModelFizickaLicaEditable extends AbstractTableModel{

    ArrayList<FizickoLice> fizickaLica;
    String[] columnNames=new String[]{"Sifra poslovnog partnera","Ime","Prezime","JMBG","Ulica","Broj","Mesto","Kontakt"};

    public TableModelFizickaLicaEditable(ArrayList<FizickoLice> fizickaLica) {
        this.fizickaLica = fizickaLica;
    }
    
    
    
    @Override
    public String getColumnName(int column) {
        return columnNames[column];
    }
    
    @Override
    public int getRowCount() {
        return fizickaLica.size();
    }

    @Override
    public int getColumnCount() {
        return columnNames.length;
    }

    @Override
    public Object getValueAt(int rowIndex, int columnIndex) {
        FizickoLice fizickoLice=fizickaLica.get(rowIndex);
        switch(columnIndex){
            case 0: return fizickoLice.getPoslovniPartnerID();
            case 1: return fizickoLice.getIme();
            case 2: return fizickoLice.getPrezime();
            case 3: return fizickoLice.getJmbg();
            case 4: return fizickoLice.getAdresa().getUlica();
            case 5: return fizickoLice.getAdresa().getBroj();
            case 6: return fizickoLice.getAdresa().getMesto();
            case 7: return fizickoLice.getKontakt();
            default: return "N/A";
        }
    }

    @Override
    public void setValueAt(Object aValue, int rowIndex, int columnIndex) {
        FizickoLice fl=fizickaLica.get(rowIndex);
        switch(columnIndex){
            case 0: fl.setPoslovniPartnerID(Integer.parseInt(aValue.toString()));break;
            case 1: fl.setIme(aValue.toString());break;
            case 2: fl.setPrezime(aValue.toString());break;
            case 3: fl.setJmbg(aValue.toString());break;
            case 4: fl.getAdresa().setUlica(aValue.toString());break;
            case 5: fl.getAdresa().setBroj(aValue.toString());break;
            case 6: fl.getAdresa().setMesto((Mesto)aValue);break;
            case 7: fl.setKontakt(aValue.toString());  break;
        }
    }

    @Override
    public boolean isCellEditable(int rowIndex, int columnIndex) {
        return true;
    }
    
    public void dodajFizickoLice(FizickoLice fizickoLice){
        fizickaLica.add(fizickoLice);
        fireTableDataChanged();
    }
    
    public FizickoLice vratiSelektovanoFizickoLice(int rowIndex){
        return fizickaLica.get(rowIndex);
    }
    
    public ArrayList<FizickoLice> vratiFizickaLica(){
        return fizickaLica;
    }
    
    
    
}
