/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package remote;

import domain.Mesto;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.ServerSocket;
import java.net.Socket;
import java.sql.SQLException;
import java.util.logging.Level;
import java.util.logging.Logger;
import logic.Kontroler;

/**
 *
 * @author student1
 */
public class Komunikacija {

    private int port;
    private Socket socket;

    private Komunikacija(int port) {
        this.port = port;
    }
    private static Komunikacija instance = null;

    public static Komunikacija getInstance() throws IOException, ClassNotFoundException, Exception {
        if (instance == null) {
            instance = new Komunikacija(9000);
            instance.pokreniServer();

        }
        return instance;
    }

    private void pokreniServer() throws IOException, ClassNotFoundException, Exception {
        ServerSocket ss = new ServerSocket(port);
        System.out.println("Server je pokrenut i ceka klijenta!");
        socket = ss.accept();
        System.out.println("Server je uspostavio komunikaciju sa klijentom!");
        izvrsenjeOperacija();
    }

    private void izvrsenjeOperacija() throws IOException, ClassNotFoundException, Exception {
        ObjectInputStream in = new ObjectInputStream(socket.getInputStream());
        ObjectOutputStream out = new ObjectOutputStream(socket.getOutputStream());

        while (true) {
            TransferniObjekat to = (TransferniObjekat) in.readObject();
            switch (to.getOperacija()) {
                case TransferniObjekat.UBACI_MESTO: {
                    Mesto m = (Mesto) to.getParametrar();
                    try {
                        Kontroler.getInstance().ubaciMesto(m);
                    } catch (SQLException ex) {
                        to.setIzuzetak(ex);
                    }
                    to.setParametrar(null);
                    out.writeObject(to);
                    break;
                }
                    
                default: throw new Exception("Ne postoji trazena operacija!");
                    
            }
        }


    }
}
