/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package komunikacija;

import domain.Mesto;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.ServerSocket;
import java.net.Socket;
import logic.Kontroler;
import remote.TransferKlasa;

/**
 *
 * @author student1
 */
public class Komunikacija {
    private int port;
    private Socket socket;
    private static Komunikacija instance;
    
    public static Komunikacija getInstance() throws IOException, ClassNotFoundException, Exception {
        if (instance == null) {
            instance = new Komunikacija(9000);
        }
        return instance;
    }
    
    private Komunikacija(int port) throws IOException, ClassNotFoundException, Exception {
        this.port = port;
        pokreniServer();
    }

    private void pokreniServer() throws IOException, ClassNotFoundException, Exception {
        ServerSocket ss = new ServerSocket(port);
        System.out.println("Server je pokrenut i spreman za rad.");
        socket = ss.accept();
        System.out.println("Klijent se povezao.");
        obradiZahteveKlijenta();
    }

    private void obradiZahteveKlijenta() throws IOException, ClassNotFoundException, Exception {
        ObjectInputStream in = new ObjectInputStream(socket.getInputStream());
        ObjectOutputStream out = new ObjectOutputStream(socket.getOutputStream());
        boolean kraj = false;
        while (!kraj) {
            TransferKlasa tk = (TransferKlasa) in.readObject();
            switch (tk.getOperacija()) {
                case TransferKlasa.SACUVAJ_MESTO:
                    System.out.println("O: SACUVAJ_MESTO");
                    Mesto mesto = (Mesto) tk.getParematar();
                    Kontroler.getInstance().ubaciMesto(mesto);
                    TransferKlasa odgovor = new TransferKlasa();
                    odgovor.setPoruka("Mesto je sacuvano!");
                    out.writeObject(odgovor);
                    break;
            }
        }
    }
    
    public static void main(String[] args) throws IOException, ClassNotFoundException, Exception {
        Komunikacija server = Komunikacija.getInstance();
    }
    
    
}
